/* This file is autogenerated by u_format_table.py from u_format.csv. Do not edit directly. */

/**************************************************************************
 *
 * Copyright 2010 VMware, Inc.
 * All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sub license, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * IN NO EVENT SHALL VMWARE AND/OR ITS SUPPLIERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 **************************************************************************/

#include "pipe/p_compiler.h"
#include "u_format.h"
#include "u_half.h"
#include "u_math.h"

const struct util_format_description
util_format_none_description = {
   PIPE_FORMAT_NONE,
   "PIPE_FORMAT_NONE",
   "none",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8a8_unorm_description = {
   PIPE_FORMAT_B8G8R8A8_UNORM,
   "PIPE_FORMAT_B8G8R8A8_UNORM",
   "b8g8r8a8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8x8_unorm_description = {
   PIPE_FORMAT_B8G8R8X8_UNORM,
   "PIPE_FORMAT_B8G8R8X8_UNORM",
   "b8g8r8x8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8x8_snorm_description = {
   PIPE_FORMAT_B8G8R8X8_SNORM,
   "PIPE_FORMAT_B8G8R8X8_SNORM",
   "b8g8r8x8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8x8_uint_description = {
   PIPE_FORMAT_B8G8R8X8_UINT,
   "PIPE_FORMAT_B8G8R8X8_UINT",
   "b8g8r8x8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8x8_sint_description = {
   PIPE_FORMAT_B8G8R8X8_SINT,
   "PIPE_FORMAT_B8G8R8X8_SINT",
   "b8g8r8x8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8r8g8b8_unorm_description = {
   PIPE_FORMAT_A8R8G8B8_UNORM,
   "PIPE_FORMAT_A8R8G8B8_UNORM",
   "a8r8g8b8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8r8g8b8_snorm_description = {
   PIPE_FORMAT_A8R8G8B8_SNORM,
   "PIPE_FORMAT_A8R8G8B8_SNORM",
   "a8r8g8b8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8r8g8b8_sint_description = {
   PIPE_FORMAT_A8R8G8B8_SINT,
   "PIPE_FORMAT_A8R8G8B8_SINT",
   "a8r8g8b8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x8r8g8b8_unorm_description = {
   PIPE_FORMAT_X8R8G8B8_UNORM,
   "PIPE_FORMAT_X8R8G8B8_UNORM",
   "x8r8g8b8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x8r8g8b8_snorm_description = {
   PIPE_FORMAT_X8R8G8B8_SNORM,
   "PIPE_FORMAT_X8R8G8B8_SNORM",
   "x8r8g8b8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x8r8g8b8_sint_description = {
   PIPE_FORMAT_X8R8G8B8_SINT,
   "PIPE_FORMAT_X8R8G8B8_SINT",
   "x8r8g8b8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8b8g8r8_unorm_description = {
   PIPE_FORMAT_A8B8G8R8_UNORM,
   "PIPE_FORMAT_A8B8G8R8_UNORM",
   "a8b8g8r8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x8b8g8r8_unorm_description = {
   PIPE_FORMAT_X8B8G8R8_UNORM,
   "PIPE_FORMAT_X8B8G8R8_UNORM",
   "x8b8g8r8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8x8_unorm_description = {
   PIPE_FORMAT_R8G8B8X8_UNORM,
   "PIPE_FORMAT_R8G8B8X8_UNORM",
   "r8g8b8x8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r5g5b5a1_unorm_description = {
   PIPE_FORMAT_R5G5B5A1_UNORM,
   "PIPE_FORMAT_R5G5B5A1_UNORM",
   "r5g5b5a1_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 15}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r5g5b5x1_unorm_description = {
   PIPE_FORMAT_R5G5B5X1_UNORM,
   "PIPE_FORMAT_R5G5B5X1_UNORM",
   "r5g5b5x1_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 15}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b5g5r5x1_unorm_description = {
   PIPE_FORMAT_B5G5R5X1_UNORM,
   "PIPE_FORMAT_B5G5R5X1_UNORM",
   "b5g5r5x1_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 15}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b5g5r5a1_unorm_description = {
   PIPE_FORMAT_B5G5R5A1_UNORM,
   "PIPE_FORMAT_B5G5R5A1_UNORM",
   "b5g5r5a1_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 15}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x1b5g5r5_unorm_description = {
   PIPE_FORMAT_X1B5G5R5_UNORM,
   "PIPE_FORMAT_X1B5G5R5_UNORM",
   "x1b5g5r5_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 15},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a1r5g5b5_unorm_description = {
   PIPE_FORMAT_A1R5G5B5_UNORM,
   "PIPE_FORMAT_A1R5G5B5_UNORM",
   "a1r5g5b5_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 15},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x1r5g5b5_unorm_description = {
   PIPE_FORMAT_X1R5G5B5_UNORM,
   "PIPE_FORMAT_X1R5G5B5_UNORM",
   "x1r5g5b5_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 15},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 1, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a1b5g5r5_unorm_description = {
   PIPE_FORMAT_A1B5G5R5_UNORM,
   "PIPE_FORMAT_A1B5G5R5_UNORM",
   "a1b5g5r5_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 15},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 10},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 5},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 1, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 1},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 6},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r4g4b4a4_unorm_description = {
   PIPE_FORMAT_R4G4B4A4_UNORM,
   "PIPE_FORMAT_R4G4B4A4_UNORM",
   "r4g4b4a4_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r4g4b4x4_unorm_description = {
   PIPE_FORMAT_R4G4B4X4_UNORM,
   "PIPE_FORMAT_R4G4B4X4_UNORM",
   "r4g4b4x4_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 4, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 4, 12}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b4g4r4a4_unorm_description = {
   PIPE_FORMAT_B4G4R4A4_UNORM,
   "PIPE_FORMAT_B4G4R4A4_UNORM",
   "b4g4r4a4_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b4g4r4x4_unorm_description = {
   PIPE_FORMAT_B4G4R4X4_UNORM,
   "PIPE_FORMAT_B4G4R4X4_UNORM",
   "b4g4r4x4_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 4, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 4, 12}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a4r4g4b4_unorm_description = {
   PIPE_FORMAT_A4R4G4B4_UNORM,
   "PIPE_FORMAT_A4R4G4B4_UNORM",
   "a4r4g4b4_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a4b4g4r4_unorm_description = {
   PIPE_FORMAT_A4B4G4R4_UNORM,
   "PIPE_FORMAT_A4B4G4R4_UNORM",
   "a4b4g4r4_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 12}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r5g6b5_unorm_description = {
   PIPE_FORMAT_R5G6B5_UNORM,
   "PIPE_FORMAT_R5G6B5_UNORM",
   "r5g6b5_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b5g6r5_unorm_description = {
   PIPE_FORMAT_B5G6R5_UNORM,
   "PIPE_FORMAT_B5G6R5_UNORM",
   "b5g6r5_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10a2_unorm_description = {
   PIPE_FORMAT_R10G10B10A2_UNORM,
   "PIPE_FORMAT_R10G10B10A2_UNORM",
   "r10g10b10a2_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10x2_unorm_description = {
   PIPE_FORMAT_R10G10B10X2_UNORM,
   "PIPE_FORMAT_R10G10B10X2_UNORM",
   "r10g10b10x2_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10a2_unorm_description = {
   PIPE_FORMAT_B10G10R10A2_UNORM,
   "PIPE_FORMAT_B10G10R10A2_UNORM",
   "b10g10r10a2_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a2r10g10b10_unorm_description = {
   PIPE_FORMAT_A2R10G10B10_UNORM,
   "PIPE_FORMAT_A2R10G10B10_UNORM",
   "a2r10g10b10_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 30},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a2b10g10r10_unorm_description = {
   PIPE_FORMAT_A2B10G10R10_UNORM,
   "PIPE_FORMAT_A2B10G10R10_UNORM",
   "a2b10g10r10_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 30},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r3g3b2_unorm_description = {
   PIPE_FORMAT_R3G3B2_UNORM,
   "PIPE_FORMAT_R3G3B2_UNORM",
   "r3g3b2_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 5},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 2},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 3},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 6},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b2g3r3_unorm_description = {
   PIPE_FORMAT_B2G3R3_UNORM,
   "PIPE_FORMAT_B2G3R3_UNORM",
   "b2g3r3_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 6},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 3},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 2},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 3, 5},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8_unorm_description = {
   PIPE_FORMAT_L8_UNORM,
   "PIPE_FORMAT_L8_UNORM",
   "l8_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8_unorm_description = {
   PIPE_FORMAT_A8_UNORM,
   "PIPE_FORMAT_A8_UNORM",
   "a8_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i8_unorm_description = {
   PIPE_FORMAT_I8_UNORM,
   "PIPE_FORMAT_I8_UNORM",
   "i8_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l4a4_unorm_description = {
   PIPE_FORMAT_L4A4_UNORM,
   "PIPE_FORMAT_L4A4_UNORM",
   "l4a4_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8a8_unorm_description = {
   PIPE_FORMAT_L8A8_UNORM,
   "PIPE_FORMAT_L8A8_UNORM",
   "l8a8_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16_unorm_description = {
   PIPE_FORMAT_L16_UNORM,
   "PIPE_FORMAT_L16_UNORM",
   "l16_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a16_unorm_description = {
   PIPE_FORMAT_A16_UNORM,
   "PIPE_FORMAT_A16_UNORM",
   "a16_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i16_unorm_description = {
   PIPE_FORMAT_I16_UNORM,
   "PIPE_FORMAT_I16_UNORM",
   "i16_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16a16_unorm_description = {
   PIPE_FORMAT_L16A16_UNORM,
   "PIPE_FORMAT_L16A16_UNORM",
   "l16a16_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8_snorm_description = {
   PIPE_FORMAT_A8_SNORM,
   "PIPE_FORMAT_A8_SNORM",
   "a8_snorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8_snorm_description = {
   PIPE_FORMAT_L8_SNORM,
   "PIPE_FORMAT_L8_SNORM",
   "l8_snorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8a8_snorm_description = {
   PIPE_FORMAT_L8A8_SNORM,
   "PIPE_FORMAT_L8A8_SNORM",
   "l8a8_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i8_snorm_description = {
   PIPE_FORMAT_I8_SNORM,
   "PIPE_FORMAT_I8_SNORM",
   "i8_snorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a16_snorm_description = {
   PIPE_FORMAT_A16_SNORM,
   "PIPE_FORMAT_A16_SNORM",
   "a16_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16_snorm_description = {
   PIPE_FORMAT_L16_SNORM,
   "PIPE_FORMAT_L16_SNORM",
   "l16_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16a16_snorm_description = {
   PIPE_FORMAT_L16A16_SNORM,
   "PIPE_FORMAT_L16A16_SNORM",
   "l16a16_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i16_snorm_description = {
   PIPE_FORMAT_I16_SNORM,
   "PIPE_FORMAT_I16_SNORM",
   "i16_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a16_float_description = {
   PIPE_FORMAT_A16_FLOAT,
   "PIPE_FORMAT_A16_FLOAT",
   "a16_float",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16_float_description = {
   PIPE_FORMAT_L16_FLOAT,
   "PIPE_FORMAT_L16_FLOAT",
   "l16_float",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16a16_float_description = {
   PIPE_FORMAT_L16A16_FLOAT,
   "PIPE_FORMAT_L16A16_FLOAT",
   "l16a16_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* x = rgb */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i16_float_description = {
   PIPE_FORMAT_I16_FLOAT,
   "PIPE_FORMAT_I16_FLOAT",
   "i16_float",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a32_float_description = {
   PIPE_FORMAT_A32_FLOAT,
   "PIPE_FORMAT_A32_FLOAT",
   "a32_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l32_float_description = {
   PIPE_FORMAT_L32_FLOAT,
   "PIPE_FORMAT_L32_FLOAT",
   "l32_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l32a32_float_description = {
   PIPE_FORMAT_L32A32_FLOAT,
   "PIPE_FORMAT_L32A32_FLOAT",
   "l32a32_float",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* x = rgb */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i32_float_description = {
   PIPE_FORMAT_I32_FLOAT,
   "PIPE_FORMAT_I32_FLOAT",
   "i32_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8_srgb_description = {
   PIPE_FORMAT_L8_SRGB,
   "PIPE_FORMAT_L8_SRGB",
   "l8_srgb",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_X,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r8_srgb_description = {
   PIPE_FORMAT_R8_SRGB,
   "PIPE_FORMAT_R8_SRGB",
   "r8_srgb",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_0,	/* sg */
      PIPE_SWIZZLE_0,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_l8a8_srgb_description = {
   PIPE_FORMAT_L8A8_SRGB,
   "PIPE_FORMAT_L8A8_SRGB",
   "l8a8_srgb",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_X,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_X,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r8g8_srgb_description = {
   PIPE_FORMAT_R8G8_SRGB,
   "PIPE_FORMAT_R8G8_SRGB",
   "r8g8_srgb",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_0,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_0,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r8g8b8_srgb_description = {
   PIPE_FORMAT_R8G8B8_SRGB,
   "PIPE_FORMAT_R8G8B8_SRGB",
   "r8g8b8_srgb",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_b8g8r8_srgb_description = {
   PIPE_FORMAT_B8G8R8_SRGB,
   "PIPE_FORMAT_B8G8R8_SRGB",
   "b8g8r8_srgb",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r8g8b8a8_srgb_description = {
   PIPE_FORMAT_R8G8B8A8_SRGB,
   "PIPE_FORMAT_R8G8B8A8_SRGB",
   "r8g8b8a8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_a8b8g8r8_srgb_description = {
   PIPE_FORMAT_A8B8G8R8_SRGB,
   "PIPE_FORMAT_A8B8G8R8_SRGB",
   "a8b8g8r8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_Y,	/* sb */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_Y,	/* sb */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_x8b8g8r8_srgb_description = {
   PIPE_FORMAT_X8B8G8R8_SRGB,
   "PIPE_FORMAT_X8B8G8R8_SRGB",
   "x8b8g8r8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_Y,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_Y,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_b8g8r8a8_srgb_description = {
   PIPE_FORMAT_B8G8R8A8_SRGB,
   "PIPE_FORMAT_B8G8R8A8_SRGB",
   "b8g8r8a8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_b8g8r8x8_srgb_description = {
   PIPE_FORMAT_B8G8R8X8_SRGB,
   "PIPE_FORMAT_B8G8R8X8_SRGB",
   "b8g8r8x8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_a8r8g8b8_srgb_description = {
   PIPE_FORMAT_A8R8G8B8_SRGB,
   "PIPE_FORMAT_A8R8G8B8_SRGB",
   "a8r8g8b8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_W,	/* sb */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_W,	/* sb */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_x8r8g8b8_srgb_description = {
   PIPE_FORMAT_X8R8G8B8_SRGB,
   "PIPE_FORMAT_X8R8G8B8_SRGB",
   "x8r8g8b8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_W,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* sr */
      PIPE_SWIZZLE_Z,	/* sg */
      PIPE_SWIZZLE_W,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r8sg8sb8ux8u_norm_description = {
   PIPE_FORMAT_R8SG8SB8UX8U_NORM,
   "PIPE_FORMAT_R8SG8SB8UX8U_NORM",
   "r8sg8sb8ux8u_norm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10sg10sb10sa2u_norm_description = {
   PIPE_FORMAT_R10SG10SB10SA2U_NORM,
   "PIPE_FORMAT_R10SG10SB10SA2U_NORM",
   "r10sg10sb10sa2u_norm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r5sg5sb6u_norm_description = {
   PIPE_FORMAT_R5SG5SB6U_NORM,
   "PIPE_FORMAT_R5SG5SB6U_NORM",
   "r5sg5sb6u_norm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 10},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_s8_uint_description = {
   PIPE_FORMAT_S8_UINT,
   "PIPE_FORMAT_S8_UINT",
   "s8_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_X,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z16_unorm_description = {
   PIPE_FORMAT_Z16_UNORM,
   "PIPE_FORMAT_Z16_UNORM",
   "z16_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z16_unorm_s8_uint_description = {
   PIPE_FORMAT_Z16_UNORM_S8_UINT,
   "PIPE_FORMAT_Z16_UNORM_S8_UINT",
   "z16_unorm_s8_uint",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 8},	/* x = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* y = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z32_unorm_description = {
   PIPE_FORMAT_Z32_UNORM,
   "PIPE_FORMAT_Z32_UNORM",
   "z32_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* x = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z32_float_description = {
   PIPE_FORMAT_Z32_FLOAT,
   "PIPE_FORMAT_Z32_FLOAT",
   "z32_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z24_unorm_s8_uint_description = {
   PIPE_FORMAT_Z24_UNORM_S8_UINT,
   "PIPE_FORMAT_Z24_UNORM_S8_UINT",
   "z24_unorm_s8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 8},	/* x = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* y = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 0},	/* x = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* y = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_s8_uint_z24_unorm_description = {
   PIPE_FORMAT_S8_UINT_Z24_UNORM,
   "PIPE_FORMAT_S8_UINT_Z24_UNORM",
   "s8_uint_z24_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = s */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 0},	/* y = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = s */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 8},	/* y = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* z */
      PIPE_SWIZZLE_X,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* z */
      PIPE_SWIZZLE_X,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_x24s8_uint_description = {
   PIPE_FORMAT_X24S8_UINT,
   "PIPE_FORMAT_X24S8_UINT",
   "x24s8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 8},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* y = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* y = s */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_s8x24_uint_description = {
   PIPE_FORMAT_S8X24_UINT,
   "PIPE_FORMAT_S8X24_UINT",
   "s8x24_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = s */
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 0},	/* y = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = s */
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 8},	/* y = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_X,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_X,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z24x8_unorm_description = {
   PIPE_FORMAT_Z24X8_UNORM,
   "PIPE_FORMAT_Z24X8_UNORM",
   "z24x8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 8},	/* x = z */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* y = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 0},	/* x = z */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* y = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_x8z24_unorm_description = {
   PIPE_FORMAT_X8Z24_UNORM,
   "PIPE_FORMAT_X8Z24_UNORM",
   "x8z24_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 0},	/* y = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 24, 8},	/* y = z */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* z */
      PIPE_SWIZZLE_NONE,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z32_float_s8x24_uint_description = {
   PIPE_FORMAT_Z32_FLOAT_S8X24_UINT,
   "PIPE_FORMAT_Z32_FLOAT_S8X24_UINT",
   "z32_float_s8x24_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   true,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* x = z */
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 8},	/* y = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* z = s */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 32},	/* y = s */
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 40},	/* z = x */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_Z,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_x32_s8x24_uint_description = {
   PIPE_FORMAT_X32_S8X24_UINT,
   "PIPE_FORMAT_X32_S8X24_UINT",
   "x32_s8x24_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 32},	/* x = x */
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 8},	/* y = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* z = s */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 32},	/* y = s */
      {UTIL_FORMAT_TYPE_VOID, false, false, 24, 40},	/* z = x */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_Z,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_NONE,	/* z */
      PIPE_SWIZZLE_Y,	/* s */
      PIPE_SWIZZLE_NONE,	/* ignored */
      PIPE_SWIZZLE_NONE	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_ZS,
};

const struct util_format_description
util_format_z24_unorm_s8_uint_as_r8g8b8a8_description = {
   PIPE_FORMAT_Z24_UNORM_S8_UINT_AS_R8G8B8A8,
   "PIPE_FORMAT_Z24_UNORM_S8_UINT_AS_R8G8B8A8",
   "z24_unorm_s8_uint_as_r8g8b8a8",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_uyvy_description = {
   PIPE_FORMAT_UYVY,
   "PIPE_FORMAT_UYVY",
   "uyvy",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_vyuy_description = {
   PIPE_FORMAT_VYUY,
   "PIPE_FORMAT_VYUY",
   "vyuy",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_yuyv_description = {
   PIPE_FORMAT_YUYV,
   "PIPE_FORMAT_YUYV",
   "yuyv",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_yvyu_description = {
   PIPE_FORMAT_YVYU,
   "PIPE_FORMAT_YVYU",
   "yvyu",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_ayuv_description = {
   PIPE_FORMAT_AYUV,
   "PIPE_FORMAT_AYUV",
   "ayuv",
   {4, 4, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_xyuv_description = {
   PIPE_FORMAT_XYUV,
   "PIPE_FORMAT_XYUV",
   "xyuv",
   {4, 4, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_r8g8_b8g8_unorm_description = {
   PIPE_FORMAT_R8G8_B8G8_UNORM,
   "PIPE_FORMAT_R8G8_B8G8_UNORM",
   "r8g8_b8g8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8r8_g8b8_unorm_description = {
   PIPE_FORMAT_G8R8_G8B8_UNORM,
   "PIPE_FORMAT_G8R8_G8B8_UNORM",
   "g8r8_g8b8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8r8_b8r8_unorm_description = {
   PIPE_FORMAT_G8R8_B8R8_UNORM,
   "PIPE_FORMAT_G8R8_B8R8_UNORM",
   "g8r8_b8r8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_r8b8_unorm_description = {
   PIPE_FORMAT_R8G8_R8B8_UNORM,
   "PIPE_FORMAT_R8G8_R8B8_UNORM",
   "r8g8_r8b8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8r8_g8r8_unorm_description = {
   PIPE_FORMAT_B8R8_G8R8_UNORM,
   "PIPE_FORMAT_B8R8_G8R8_UNORM",
   "b8r8_g8r8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8b8_r8g8_unorm_description = {
   PIPE_FORMAT_R8B8_R8G8_UNORM,
   "PIPE_FORMAT_R8B8_R8G8_UNORM",
   "r8b8_r8g8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8b8_g8r8_unorm_description = {
   PIPE_FORMAT_G8B8_G8R8_UNORM,
   "PIPE_FORMAT_G8B8_G8R8_UNORM",
   "g8b8_g8r8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8_r8g8_unorm_description = {
   PIPE_FORMAT_B8G8_R8G8_UNORM,
   "PIPE_FORMAT_B8G8_R8G8_UNORM",
   "b8g8_r8g8_unorm",
   {2, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r11g11b10_float_description = {
   PIPE_FORMAT_R11G11B10_FLOAT,
   "PIPE_FORMAT_R11G11B10_FLOAT",
   "r11g11b10_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   3,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 11, 21},	/* x = x */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 11, 10},	/* y = y */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 10, 0},	/* z = z */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 11, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 11, 11},	/* y = y */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 10, 22},	/* z = z */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r9g9b9e5_float_description = {
   PIPE_FORMAT_R9G9B9E5_FLOAT,
   "PIPE_FORMAT_R9G9B9E5_FLOAT",
   "r9g9b9e5_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 9, 23},	/* x = x */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 9, 14},	/* y = y */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 9, 5},	/* z = z */
      {UTIL_FORMAT_TYPE_VOID, false, false, 5, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 9, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 9, 9},	/* y = y */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 9, 18},	/* z = z */
      {UTIL_FORMAT_TYPE_VOID, false, false, 5, 27}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r1_unorm_description = {
   PIPE_FORMAT_R1_UNORM,
   "PIPE_FORMAT_R1_UNORM",
   "r1_unorm",
   {8, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8bx_snorm_description = {
   PIPE_FORMAT_R8G8Bx_SNORM,
   "PIPE_FORMAT_R8G8Bx_SNORM",
   "r8g8bx_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   2,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* y = y */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = y */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_dxt1_rgb_description = {
   PIPE_FORMAT_DXT1_RGB,
   "PIPE_FORMAT_DXT1_RGB",
   "dxt1_rgb",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_dxt1_rgba_description = {
   PIPE_FORMAT_DXT1_RGBA,
   "PIPE_FORMAT_DXT1_RGBA",
   "dxt1_rgba",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_dxt3_rgba_description = {
   PIPE_FORMAT_DXT3_RGBA,
   "PIPE_FORMAT_DXT3_RGBA",
   "dxt3_rgba",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_dxt5_rgba_description = {
   PIPE_FORMAT_DXT5_RGBA,
   "PIPE_FORMAT_DXT5_RGBA",
   "dxt5_rgba",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_dxt1_srgb_description = {
   PIPE_FORMAT_DXT1_SRGB,
   "PIPE_FORMAT_DXT1_SRGB",
   "dxt1_srgb",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_dxt1_srgba_description = {
   PIPE_FORMAT_DXT1_SRGBA,
   "PIPE_FORMAT_DXT1_SRGBA",
   "dxt1_srgba",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_dxt3_srgba_description = {
   PIPE_FORMAT_DXT3_SRGBA,
   "PIPE_FORMAT_DXT3_SRGBA",
   "dxt3_srgba",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_dxt5_srgba_description = {
   PIPE_FORMAT_DXT5_SRGBA,
   "PIPE_FORMAT_DXT5_SRGBA",
   "dxt5_srgba",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_S3TC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_fxt1_rgb_description = {
   PIPE_FORMAT_FXT1_RGB,
   "PIPE_FORMAT_FXT1_RGB",
   "fxt1_rgb",
   {8, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_FXT1,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_fxt1_rgba_description = {
   PIPE_FORMAT_FXT1_RGBA,
   "PIPE_FORMAT_FXT1_RGBA",
   "fxt1_rgba",
   {8, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_FXT1,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_rgtc1_unorm_description = {
   PIPE_FORMAT_RGTC1_UNORM,
   "PIPE_FORMAT_RGTC1_UNORM",
   "rgtc1_unorm",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_rgtc1_snorm_description = {
   PIPE_FORMAT_RGTC1_SNORM,
   "PIPE_FORMAT_RGTC1_SNORM",
   "rgtc1_snorm",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_rgtc2_unorm_description = {
   PIPE_FORMAT_RGTC2_UNORM,
   "PIPE_FORMAT_RGTC2_UNORM",
   "rgtc2_unorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_rgtc2_snorm_description = {
   PIPE_FORMAT_RGTC2_SNORM,
   "PIPE_FORMAT_RGTC2_SNORM",
   "rgtc2_snorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_latc1_unorm_description = {
   PIPE_FORMAT_LATC1_UNORM,
   "PIPE_FORMAT_LATC1_UNORM",
   "latc1_unorm",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_latc1_snorm_description = {
   PIPE_FORMAT_LATC1_SNORM,
   "PIPE_FORMAT_LATC1_SNORM",
   "latc1_snorm",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_latc2_unorm_description = {
   PIPE_FORMAT_LATC2_UNORM,
   "PIPE_FORMAT_LATC2_UNORM",
   "latc2_unorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_latc2_snorm_description = {
   PIPE_FORMAT_LATC2_SNORM,
   "PIPE_FORMAT_LATC2_SNORM",
   "latc2_snorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_RGTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc1_rgb8_description = {
   PIPE_FORMAT_ETC1_RGB8,
   "PIPE_FORMAT_ETC1_RGB8",
   "etc1_rgb8",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_rgb8_description = {
   PIPE_FORMAT_ETC2_RGB8,
   "PIPE_FORMAT_ETC2_RGB8",
   "etc2_rgb8",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_srgb8_description = {
   PIPE_FORMAT_ETC2_SRGB8,
   "PIPE_FORMAT_ETC2_SRGB8",
   "etc2_srgb8",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_etc2_rgb8a1_description = {
   PIPE_FORMAT_ETC2_RGB8A1,
   "PIPE_FORMAT_ETC2_RGB8A1",
   "etc2_rgb8a1",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_srgb8a1_description = {
   PIPE_FORMAT_ETC2_SRGB8A1,
   "PIPE_FORMAT_ETC2_SRGB8A1",
   "etc2_srgb8a1",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_etc2_rgba8_description = {
   PIPE_FORMAT_ETC2_RGBA8,
   "PIPE_FORMAT_ETC2_RGBA8",
   "etc2_rgba8",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_srgba8_description = {
   PIPE_FORMAT_ETC2_SRGBA8,
   "PIPE_FORMAT_ETC2_SRGBA8",
   "etc2_srgba8",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_etc2_r11_unorm_description = {
   PIPE_FORMAT_ETC2_R11_UNORM,
   "PIPE_FORMAT_ETC2_R11_UNORM",
   "etc2_r11_unorm",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_r11_snorm_description = {
   PIPE_FORMAT_ETC2_R11_SNORM,
   "PIPE_FORMAT_ETC2_R11_SNORM",
   "etc2_r11_snorm",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_rg11_unorm_description = {
   PIPE_FORMAT_ETC2_RG11_UNORM,
   "PIPE_FORMAT_ETC2_RG11_UNORM",
   "etc2_rg11_unorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_etc2_rg11_snorm_description = {
   PIPE_FORMAT_ETC2_RG11_SNORM,
   "PIPE_FORMAT_ETC2_RG11_SNORM",
   "etc2_rg11_snorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ETC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_bptc_rgba_unorm_description = {
   PIPE_FORMAT_BPTC_RGBA_UNORM,
   "PIPE_FORMAT_BPTC_RGBA_UNORM",
   "bptc_rgba_unorm",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_BPTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_bptc_srgba_description = {
   PIPE_FORMAT_BPTC_SRGBA,
   "PIPE_FORMAT_BPTC_SRGBA",
   "bptc_srgba",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_BPTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_bptc_rgb_float_description = {
   PIPE_FORMAT_BPTC_RGB_FLOAT,
   "PIPE_FORMAT_BPTC_RGB_FLOAT",
   "bptc_rgb_float",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_BPTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_bptc_rgb_ufloat_description = {
   PIPE_FORMAT_BPTC_RGB_UFLOAT,
   "PIPE_FORMAT_BPTC_RGB_UFLOAT",
   "bptc_rgb_ufloat",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_BPTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_4x4_description = {
   PIPE_FORMAT_ASTC_4x4,
   "PIPE_FORMAT_ASTC_4x4",
   "astc_4x4",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_5x4_description = {
   PIPE_FORMAT_ASTC_5x4,
   "PIPE_FORMAT_ASTC_5x4",
   "astc_5x4",
   {5, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_5x5_description = {
   PIPE_FORMAT_ASTC_5x5,
   "PIPE_FORMAT_ASTC_5x5",
   "astc_5x5",
   {5, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_6x5_description = {
   PIPE_FORMAT_ASTC_6x5,
   "PIPE_FORMAT_ASTC_6x5",
   "astc_6x5",
   {6, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_6x6_description = {
   PIPE_FORMAT_ASTC_6x6,
   "PIPE_FORMAT_ASTC_6x6",
   "astc_6x6",
   {6, 6, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_8x5_description = {
   PIPE_FORMAT_ASTC_8x5,
   "PIPE_FORMAT_ASTC_8x5",
   "astc_8x5",
   {8, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_8x6_description = {
   PIPE_FORMAT_ASTC_8x6,
   "PIPE_FORMAT_ASTC_8x6",
   "astc_8x6",
   {8, 6, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_8x8_description = {
   PIPE_FORMAT_ASTC_8x8,
   "PIPE_FORMAT_ASTC_8x8",
   "astc_8x8",
   {8, 8, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_10x5_description = {
   PIPE_FORMAT_ASTC_10x5,
   "PIPE_FORMAT_ASTC_10x5",
   "astc_10x5",
   {10, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_10x6_description = {
   PIPE_FORMAT_ASTC_10x6,
   "PIPE_FORMAT_ASTC_10x6",
   "astc_10x6",
   {10, 6, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_10x8_description = {
   PIPE_FORMAT_ASTC_10x8,
   "PIPE_FORMAT_ASTC_10x8",
   "astc_10x8",
   {10, 8, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_10x10_description = {
   PIPE_FORMAT_ASTC_10x10,
   "PIPE_FORMAT_ASTC_10x10",
   "astc_10x10",
   {10, 10, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_12x10_description = {
   PIPE_FORMAT_ASTC_12x10,
   "PIPE_FORMAT_ASTC_12x10",
   "astc_12x10",
   {12, 10, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_12x12_description = {
   PIPE_FORMAT_ASTC_12x12,
   "PIPE_FORMAT_ASTC_12x12",
   "astc_12x12",
   {12, 12, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_4x4_srgb_description = {
   PIPE_FORMAT_ASTC_4x4_SRGB,
   "PIPE_FORMAT_ASTC_4x4_SRGB",
   "astc_4x4_srgb",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_5x4_srgb_description = {
   PIPE_FORMAT_ASTC_5x4_SRGB,
   "PIPE_FORMAT_ASTC_5x4_SRGB",
   "astc_5x4_srgb",
   {5, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_5x5_srgb_description = {
   PIPE_FORMAT_ASTC_5x5_SRGB,
   "PIPE_FORMAT_ASTC_5x5_SRGB",
   "astc_5x5_srgb",
   {5, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_6x5_srgb_description = {
   PIPE_FORMAT_ASTC_6x5_SRGB,
   "PIPE_FORMAT_ASTC_6x5_SRGB",
   "astc_6x5_srgb",
   {6, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_6x6_srgb_description = {
   PIPE_FORMAT_ASTC_6x6_SRGB,
   "PIPE_FORMAT_ASTC_6x6_SRGB",
   "astc_6x6_srgb",
   {6, 6, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_8x5_srgb_description = {
   PIPE_FORMAT_ASTC_8x5_SRGB,
   "PIPE_FORMAT_ASTC_8x5_SRGB",
   "astc_8x5_srgb",
   {8, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_8x6_srgb_description = {
   PIPE_FORMAT_ASTC_8x6_SRGB,
   "PIPE_FORMAT_ASTC_8x6_SRGB",
   "astc_8x6_srgb",
   {8, 6, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_8x8_srgb_description = {
   PIPE_FORMAT_ASTC_8x8_SRGB,
   "PIPE_FORMAT_ASTC_8x8_SRGB",
   "astc_8x8_srgb",
   {8, 8, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_10x5_srgb_description = {
   PIPE_FORMAT_ASTC_10x5_SRGB,
   "PIPE_FORMAT_ASTC_10x5_SRGB",
   "astc_10x5_srgb",
   {10, 5, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_10x6_srgb_description = {
   PIPE_FORMAT_ASTC_10x6_SRGB,
   "PIPE_FORMAT_ASTC_10x6_SRGB",
   "astc_10x6_srgb",
   {10, 6, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_10x8_srgb_description = {
   PIPE_FORMAT_ASTC_10x8_SRGB,
   "PIPE_FORMAT_ASTC_10x8_SRGB",
   "astc_10x8_srgb",
   {10, 8, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_10x10_srgb_description = {
   PIPE_FORMAT_ASTC_10x10_SRGB,
   "PIPE_FORMAT_ASTC_10x10_SRGB",
   "astc_10x10_srgb",
   {10, 10, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_12x10_srgb_description = {
   PIPE_FORMAT_ASTC_12x10_SRGB,
   "PIPE_FORMAT_ASTC_12x10_SRGB",
   "astc_12x10_srgb",
   {12, 10, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_12x12_srgb_description = {
   PIPE_FORMAT_ASTC_12x12_SRGB,
   "PIPE_FORMAT_ASTC_12x12_SRGB",
   "astc_12x12_srgb",
   {12, 12, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_3x3x3_description = {
   PIPE_FORMAT_ASTC_3x3x3,
   "PIPE_FORMAT_ASTC_3x3x3",
   "astc_3x3x3",
   {3, 3, 3, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_4x3x3_description = {
   PIPE_FORMAT_ASTC_4x3x3,
   "PIPE_FORMAT_ASTC_4x3x3",
   "astc_4x3x3",
   {4, 3, 3, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_4x4x3_description = {
   PIPE_FORMAT_ASTC_4x4x3,
   "PIPE_FORMAT_ASTC_4x4x3",
   "astc_4x4x3",
   {4, 4, 3, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_4x4x4_description = {
   PIPE_FORMAT_ASTC_4x4x4,
   "PIPE_FORMAT_ASTC_4x4x4",
   "astc_4x4x4",
   {4, 4, 4, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_5x4x4_description = {
   PIPE_FORMAT_ASTC_5x4x4,
   "PIPE_FORMAT_ASTC_5x4x4",
   "astc_5x4x4",
   {5, 4, 4, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_5x5x4_description = {
   PIPE_FORMAT_ASTC_5x5x4,
   "PIPE_FORMAT_ASTC_5x5x4",
   "astc_5x5x4",
   {5, 5, 4, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_5x5x5_description = {
   PIPE_FORMAT_ASTC_5x5x5,
   "PIPE_FORMAT_ASTC_5x5x5",
   "astc_5x5x5",
   {5, 5, 5, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_6x5x5_description = {
   PIPE_FORMAT_ASTC_6x5x5,
   "PIPE_FORMAT_ASTC_6x5x5",
   "astc_6x5x5",
   {6, 5, 5, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_6x6x5_description = {
   PIPE_FORMAT_ASTC_6x6x5,
   "PIPE_FORMAT_ASTC_6x6x5",
   "astc_6x6x5",
   {6, 6, 5, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_6x6x6_description = {
   PIPE_FORMAT_ASTC_6x6x6,
   "PIPE_FORMAT_ASTC_6x6x6",
   "astc_6x6x6",
   {6, 6, 6, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_astc_3x3x3_srgb_description = {
   PIPE_FORMAT_ASTC_3x3x3_SRGB,
   "PIPE_FORMAT_ASTC_3x3x3_SRGB",
   "astc_3x3x3_srgb",
   {3, 3, 3, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_4x3x3_srgb_description = {
   PIPE_FORMAT_ASTC_4x3x3_SRGB,
   "PIPE_FORMAT_ASTC_4x3x3_SRGB",
   "astc_4x3x3_srgb",
   {4, 3, 3, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_4x4x3_srgb_description = {
   PIPE_FORMAT_ASTC_4x4x3_SRGB,
   "PIPE_FORMAT_ASTC_4x4x3_SRGB",
   "astc_4x4x3_srgb",
   {4, 4, 3, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_4x4x4_srgb_description = {
   PIPE_FORMAT_ASTC_4x4x4_SRGB,
   "PIPE_FORMAT_ASTC_4x4x4_SRGB",
   "astc_4x4x4_srgb",
   {4, 4, 4, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_5x4x4_srgb_description = {
   PIPE_FORMAT_ASTC_5x4x4_SRGB,
   "PIPE_FORMAT_ASTC_5x4x4_SRGB",
   "astc_5x4x4_srgb",
   {5, 4, 4, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_5x5x4_srgb_description = {
   PIPE_FORMAT_ASTC_5x5x4_SRGB,
   "PIPE_FORMAT_ASTC_5x5x4_SRGB",
   "astc_5x5x4_srgb",
   {5, 5, 4, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_5x5x5_srgb_description = {
   PIPE_FORMAT_ASTC_5x5x5_SRGB,
   "PIPE_FORMAT_ASTC_5x5x5_SRGB",
   "astc_5x5x5_srgb",
   {5, 5, 5, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_6x5x5_srgb_description = {
   PIPE_FORMAT_ASTC_6x5x5_SRGB,
   "PIPE_FORMAT_ASTC_6x5x5_SRGB",
   "astc_6x5x5_srgb",
   {6, 5, 5, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_6x6x5_srgb_description = {
   PIPE_FORMAT_ASTC_6x6x5_SRGB,
   "PIPE_FORMAT_ASTC_6x6x5_SRGB",
   "astc_6x6x5_srgb",
   {6, 6, 5, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_astc_6x6x6_srgb_description = {
   PIPE_FORMAT_ASTC_6x6x6_SRGB,
   "PIPE_FORMAT_ASTC_6x6x6_SRGB",
   "astc_6x6x6_srgb",
   {6, 6, 6, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ASTC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_atc_rgb_description = {
   PIPE_FORMAT_ATC_RGB,
   "PIPE_FORMAT_ATC_RGB",
   "atc_rgb",
   {4, 4, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_ATC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_atc_rgba_explicit_description = {
   PIPE_FORMAT_ATC_RGBA_EXPLICIT,
   "PIPE_FORMAT_ATC_RGBA_EXPLICIT",
   "atc_rgba_explicit",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ATC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_atc_rgba_interpolated_description = {
   PIPE_FORMAT_ATC_RGBA_INTERPOLATED,
   "PIPE_FORMAT_ATC_RGBA_INTERPOLATED",
   "atc_rgba_interpolated",
   {4, 4, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_ATC,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 128, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64_float_description = {
   PIPE_FORMAT_R64_FLOAT,
   "PIPE_FORMAT_R64_FLOAT",
   "r64_float",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64_float_description = {
   PIPE_FORMAT_R64G64_FLOAT,
   "PIPE_FORMAT_R64G64_FLOAT",
   "r64g64_float",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 64},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64b64_float_description = {
   PIPE_FORMAT_R64G64B64_FLOAT,
   "PIPE_FORMAT_R64G64B64_FLOAT",
   "r64g64b64_float",
   {1, 1, 1, 192},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 128},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 128},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64b64a64_float_description = {
   PIPE_FORMAT_R64G64B64A64_FLOAT,
   "PIPE_FORMAT_R64G64B64A64_FLOAT",
   "r64g64b64a64_float",
   {1, 1, 1, 256},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 192},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 128},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 128},	/* z = b */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 64, 192}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_float_description = {
   PIPE_FORMAT_R32_FLOAT,
   "PIPE_FORMAT_R32_FLOAT",
   "r32_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_float_description = {
   PIPE_FORMAT_R32G32_FLOAT,
   "PIPE_FORMAT_R32G32_FLOAT",
   "r32g32_float",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_float_description = {
   PIPE_FORMAT_R32G32B32_FLOAT,
   "PIPE_FORMAT_R32G32B32_FLOAT",
   "r32g32b32_float",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_float_description = {
   PIPE_FORMAT_R32G32B32A32_FLOAT,
   "PIPE_FORMAT_R32G32B32A32_FLOAT",
   "r32g32b32a32_float",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_unorm_description = {
   PIPE_FORMAT_R32_UNORM,
   "PIPE_FORMAT_R32_UNORM",
   "r32_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_unorm_description = {
   PIPE_FORMAT_R32G32_UNORM,
   "PIPE_FORMAT_R32G32_UNORM",
   "r32g32_unorm",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_unorm_description = {
   PIPE_FORMAT_R32G32B32_UNORM,
   "PIPE_FORMAT_R32G32B32_UNORM",
   "r32g32b32_unorm",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_unorm_description = {
   PIPE_FORMAT_R32G32B32A32_UNORM,
   "PIPE_FORMAT_R32G32B32A32_UNORM",
   "r32g32b32a32_unorm",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_uscaled_description = {
   PIPE_FORMAT_R32_USCALED,
   "PIPE_FORMAT_R32_USCALED",
   "r32_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_uscaled_description = {
   PIPE_FORMAT_R32G32_USCALED,
   "PIPE_FORMAT_R32G32_USCALED",
   "r32g32_uscaled",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_uscaled_description = {
   PIPE_FORMAT_R32G32B32_USCALED,
   "PIPE_FORMAT_R32G32B32_USCALED",
   "r32g32b32_uscaled",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_uscaled_description = {
   PIPE_FORMAT_R32G32B32A32_USCALED,
   "PIPE_FORMAT_R32G32B32A32_USCALED",
   "r32g32b32a32_uscaled",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_snorm_description = {
   PIPE_FORMAT_R32_SNORM,
   "PIPE_FORMAT_R32_SNORM",
   "r32_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_snorm_description = {
   PIPE_FORMAT_R32G32_SNORM,
   "PIPE_FORMAT_R32G32_SNORM",
   "r32g32_snorm",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_snorm_description = {
   PIPE_FORMAT_R32G32B32_SNORM,
   "PIPE_FORMAT_R32G32B32_SNORM",
   "r32g32b32_snorm",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_snorm_description = {
   PIPE_FORMAT_R32G32B32A32_SNORM,
   "PIPE_FORMAT_R32G32B32A32_SNORM",
   "r32g32b32a32_snorm",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_sscaled_description = {
   PIPE_FORMAT_R32_SSCALED,
   "PIPE_FORMAT_R32_SSCALED",
   "r32_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_sscaled_description = {
   PIPE_FORMAT_R32G32_SSCALED,
   "PIPE_FORMAT_R32G32_SSCALED",
   "r32g32_sscaled",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_sscaled_description = {
   PIPE_FORMAT_R32G32B32_SSCALED,
   "PIPE_FORMAT_R32G32B32_SSCALED",
   "r32g32b32_sscaled",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_sscaled_description = {
   PIPE_FORMAT_R32G32B32A32_SSCALED,
   "PIPE_FORMAT_R32G32B32A32_SSCALED",
   "r32g32b32a32_sscaled",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_float_description = {
   PIPE_FORMAT_R16_FLOAT,
   "PIPE_FORMAT_R16_FLOAT",
   "r16_float",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_float_description = {
   PIPE_FORMAT_R16G16_FLOAT,
   "PIPE_FORMAT_R16G16_FLOAT",
   "r16g16_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_float_description = {
   PIPE_FORMAT_R16G16B16_FLOAT,
   "PIPE_FORMAT_R16G16B16_FLOAT",
   "r16g16b16_float",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_float_description = {
   PIPE_FORMAT_R16G16B16A16_FLOAT,
   "PIPE_FORMAT_R16G16B16A16_FLOAT",
   "r16g16b16a16_float",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_unorm_description = {
   PIPE_FORMAT_R16_UNORM,
   "PIPE_FORMAT_R16_UNORM",
   "r16_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_unorm_description = {
   PIPE_FORMAT_R16G16_UNORM,
   "PIPE_FORMAT_R16G16_UNORM",
   "r16g16_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_unorm_description = {
   PIPE_FORMAT_R16G16B16_UNORM,
   "PIPE_FORMAT_R16G16B16_UNORM",
   "r16g16b16_unorm",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_unorm_description = {
   PIPE_FORMAT_R16G16B16A16_UNORM,
   "PIPE_FORMAT_R16G16B16A16_UNORM",
   "r16g16b16a16_unorm",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_uscaled_description = {
   PIPE_FORMAT_R16_USCALED,
   "PIPE_FORMAT_R16_USCALED",
   "r16_uscaled",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_uscaled_description = {
   PIPE_FORMAT_R16G16_USCALED,
   "PIPE_FORMAT_R16G16_USCALED",
   "r16g16_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_uscaled_description = {
   PIPE_FORMAT_R16G16B16_USCALED,
   "PIPE_FORMAT_R16G16B16_USCALED",
   "r16g16b16_uscaled",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_uscaled_description = {
   PIPE_FORMAT_R16G16B16A16_USCALED,
   "PIPE_FORMAT_R16G16B16A16_USCALED",
   "r16g16b16a16_uscaled",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_snorm_description = {
   PIPE_FORMAT_R16_SNORM,
   "PIPE_FORMAT_R16_SNORM",
   "r16_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_snorm_description = {
   PIPE_FORMAT_R16G16_SNORM,
   "PIPE_FORMAT_R16G16_SNORM",
   "r16g16_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_snorm_description = {
   PIPE_FORMAT_R16G16B16_SNORM,
   "PIPE_FORMAT_R16G16B16_SNORM",
   "r16g16b16_snorm",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_snorm_description = {
   PIPE_FORMAT_R16G16B16A16_SNORM,
   "PIPE_FORMAT_R16G16B16A16_SNORM",
   "r16g16b16a16_snorm",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_sscaled_description = {
   PIPE_FORMAT_R16_SSCALED,
   "PIPE_FORMAT_R16_SSCALED",
   "r16_sscaled",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_sscaled_description = {
   PIPE_FORMAT_R16G16_SSCALED,
   "PIPE_FORMAT_R16G16_SSCALED",
   "r16g16_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_sscaled_description = {
   PIPE_FORMAT_R16G16B16_SSCALED,
   "PIPE_FORMAT_R16G16B16_SSCALED",
   "r16g16b16_sscaled",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_sscaled_description = {
   PIPE_FORMAT_R16G16B16A16_SSCALED,
   "PIPE_FORMAT_R16G16B16A16_SSCALED",
   "r16g16b16a16_sscaled",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_unorm_description = {
   PIPE_FORMAT_R8_UNORM,
   "PIPE_FORMAT_R8_UNORM",
   "r8_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_unorm_description = {
   PIPE_FORMAT_R8G8_UNORM,
   "PIPE_FORMAT_R8G8_UNORM",
   "r8g8_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8_unorm_description = {
   PIPE_FORMAT_R8G8B8_UNORM,
   "PIPE_FORMAT_R8G8B8_UNORM",
   "r8g8b8_unorm",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8_unorm_description = {
   PIPE_FORMAT_B8G8R8_UNORM,
   "PIPE_FORMAT_B8G8R8_UNORM",
   "b8g8r8_unorm",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8a8_unorm_description = {
   PIPE_FORMAT_R8G8B8A8_UNORM,
   "PIPE_FORMAT_R8G8B8A8_UNORM",
   "r8g8b8a8_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_uscaled_description = {
   PIPE_FORMAT_R8_USCALED,
   "PIPE_FORMAT_R8_USCALED",
   "r8_uscaled",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_uscaled_description = {
   PIPE_FORMAT_R8G8_USCALED,
   "PIPE_FORMAT_R8G8_USCALED",
   "r8g8_uscaled",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8_uscaled_description = {
   PIPE_FORMAT_R8G8B8_USCALED,
   "PIPE_FORMAT_R8G8B8_USCALED",
   "r8g8b8_uscaled",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8_uscaled_description = {
   PIPE_FORMAT_B8G8R8_USCALED,
   "PIPE_FORMAT_B8G8R8_USCALED",
   "b8g8r8_uscaled",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8a8_uscaled_description = {
   PIPE_FORMAT_R8G8B8A8_USCALED,
   "PIPE_FORMAT_R8G8B8A8_USCALED",
   "r8g8b8a8_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8a8_uscaled_description = {
   PIPE_FORMAT_B8G8R8A8_USCALED,
   "PIPE_FORMAT_B8G8R8A8_USCALED",
   "b8g8r8a8_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8b8g8r8_uscaled_description = {
   PIPE_FORMAT_A8B8G8R8_USCALED,
   "PIPE_FORMAT_A8B8G8R8_USCALED",
   "a8b8g8r8_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_snorm_description = {
   PIPE_FORMAT_R8_SNORM,
   "PIPE_FORMAT_R8_SNORM",
   "r8_snorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_snorm_description = {
   PIPE_FORMAT_R8G8_SNORM,
   "PIPE_FORMAT_R8G8_SNORM",
   "r8g8_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8_snorm_description = {
   PIPE_FORMAT_R8G8B8_SNORM,
   "PIPE_FORMAT_R8G8B8_SNORM",
   "r8g8b8_snorm",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8_snorm_description = {
   PIPE_FORMAT_B8G8R8_SNORM,
   "PIPE_FORMAT_B8G8R8_SNORM",
   "b8g8r8_snorm",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8a8_snorm_description = {
   PIPE_FORMAT_R8G8B8A8_SNORM,
   "PIPE_FORMAT_R8G8B8A8_SNORM",
   "r8g8b8a8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8a8_snorm_description = {
   PIPE_FORMAT_B8G8R8A8_SNORM,
   "PIPE_FORMAT_B8G8R8A8_SNORM",
   "b8g8r8a8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_sscaled_description = {
   PIPE_FORMAT_R8_SSCALED,
   "PIPE_FORMAT_R8_SSCALED",
   "r8_sscaled",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_sscaled_description = {
   PIPE_FORMAT_R8G8_SSCALED,
   "PIPE_FORMAT_R8G8_SSCALED",
   "r8g8_sscaled",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8_sscaled_description = {
   PIPE_FORMAT_R8G8B8_SSCALED,
   "PIPE_FORMAT_R8G8B8_SSCALED",
   "r8g8b8_sscaled",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8_sscaled_description = {
   PIPE_FORMAT_B8G8R8_SSCALED,
   "PIPE_FORMAT_B8G8R8_SSCALED",
   "b8g8r8_sscaled",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8a8_sscaled_description = {
   PIPE_FORMAT_R8G8B8A8_SSCALED,
   "PIPE_FORMAT_R8G8B8A8_SSCALED",
   "r8g8b8a8_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8a8_sscaled_description = {
   PIPE_FORMAT_B8G8R8A8_SSCALED,
   "PIPE_FORMAT_B8G8R8A8_SSCALED",
   "b8g8r8a8_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8b8g8r8_sscaled_description = {
   PIPE_FORMAT_A8B8G8R8_SSCALED,
   "PIPE_FORMAT_A8B8G8R8_SSCALED",
   "a8b8g8r8_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_fixed_description = {
   PIPE_FORMAT_R32_FIXED,
   "PIPE_FORMAT_R32_FIXED",
   "r32_fixed",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_fixed_description = {
   PIPE_FORMAT_R32G32_FIXED,
   "PIPE_FORMAT_R32G32_FIXED",
   "r32g32_fixed",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_fixed_description = {
   PIPE_FORMAT_R32G32B32_FIXED,
   "PIPE_FORMAT_R32G32B32_FIXED",
   "r32g32b32_fixed",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_fixed_description = {
   PIPE_FORMAT_R32G32B32A32_FIXED,
   "PIPE_FORMAT_R32G32B32A32_FIXED",
   "r32g32b32a32_fixed",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_FIXED, false, false, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10x2_uscaled_description = {
   PIPE_FORMAT_R10G10B10X2_USCALED,
   "PIPE_FORMAT_R10G10B10X2_USCALED",
   "r10g10b10x2_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10x2_snorm_description = {
   PIPE_FORMAT_R10G10B10X2_SNORM,
   "PIPE_FORMAT_R10G10B10X2_SNORM",
   "r10g10b10x2_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10x2_sint_description = {
   PIPE_FORMAT_R10G10B10X2_SINT,
   "PIPE_FORMAT_R10G10B10X2_SINT",
   "r10g10b10x2_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_yv12_description = {
   PIPE_FORMAT_YV12,
   "PIPE_FORMAT_YV12",
   "yv12",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_yv16_description = {
   PIPE_FORMAT_YV16,
   "PIPE_FORMAT_YV16",
   "yv16",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_iyuv_description = {
   PIPE_FORMAT_IYUV,
   "PIPE_FORMAT_IYUV",
   "iyuv",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_nv12_description = {
   PIPE_FORMAT_NV12,
   "PIPE_FORMAT_NV12",
   "nv12",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_nv21_description = {
   PIPE_FORMAT_NV21,
   "PIPE_FORMAT_NV21",
   "nv21",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y8_400_unorm_description = {
   PIPE_FORMAT_Y8_400_UNORM,
   "PIPE_FORMAT_Y8_400_UNORM",
   "y8_400_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_0,	/* u */
      PIPE_SWIZZLE_0,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_r8_g8b8_420_unorm_description = {
   PIPE_FORMAT_R8_G8B8_420_UNORM,
   "PIPE_FORMAT_R8_G8B8_420_UNORM",
   "r8_g8b8_420_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_b8g8_420_unorm_description = {
   PIPE_FORMAT_R8_B8G8_420_UNORM,
   "PIPE_FORMAT_R8_B8G8_420_UNORM",
   "r8_b8g8_420_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8_b8r8_420_unorm_description = {
   PIPE_FORMAT_G8_B8R8_420_UNORM,
   "PIPE_FORMAT_G8_B8R8_420_UNORM",
   "g8_b8r8_420_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_g8_b8_420_unorm_description = {
   PIPE_FORMAT_R8_G8_B8_420_UNORM,
   "PIPE_FORMAT_R8_G8_B8_420_UNORM",
   "r8_g8_b8_420_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_b8_g8_420_unorm_description = {
   PIPE_FORMAT_R8_B8_G8_420_UNORM,
   "PIPE_FORMAT_R8_B8_G8_420_UNORM",
   "r8_b8_g8_420_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8_b8_r8_420_unorm_description = {
   PIPE_FORMAT_G8_B8_R8_420_UNORM,
   "PIPE_FORMAT_G8_B8_R8_420_UNORM",
   "g8_b8_r8_420_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_g8_b8_unorm_description = {
   PIPE_FORMAT_R8_G8_B8_UNORM,
   "PIPE_FORMAT_R8_G8_B8_UNORM",
   "r8_g8_b8_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_y8_unorm_description = {
   PIPE_FORMAT_Y8_UNORM,
   "PIPE_FORMAT_Y8_UNORM",
   "y8_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_0,	/* u */
      PIPE_SWIZZLE_0,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y8_u8_v8_422_unorm_description = {
   PIPE_FORMAT_Y8_U8_V8_422_UNORM,
   "PIPE_FORMAT_Y8_U8_V8_422_UNORM",
   "y8_u8_v8_422_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y8_u8v8_422_unorm_description = {
   PIPE_FORMAT_Y8_U8V8_422_UNORM,
   "PIPE_FORMAT_Y8_U8V8_422_UNORM",
   "y8_u8v8_422_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y8_u8_v8_444_unorm_description = {
   PIPE_FORMAT_Y8_U8_V8_444_UNORM,
   "PIPE_FORMAT_Y8_U8_V8_444_UNORM",
   "y8_u8_v8_444_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y16_u16_v16_420_unorm_description = {
   PIPE_FORMAT_Y16_U16_V16_420_UNORM,
   "PIPE_FORMAT_Y16_U16_V16_420_UNORM",
   "y16_u16_v16_420_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y16_u16_v16_422_unorm_description = {
   PIPE_FORMAT_Y16_U16_V16_422_UNORM,
   "PIPE_FORMAT_Y16_U16_V16_422_UNORM",
   "y16_u16_v16_422_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y16_u16v16_422_unorm_description = {
   PIPE_FORMAT_Y16_U16V16_422_UNORM,
   "PIPE_FORMAT_Y16_U16V16_422_UNORM",
   "y16_u16v16_422_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y16_u16_v16_444_unorm_description = {
   PIPE_FORMAT_Y16_U16_V16_444_UNORM,
   "PIPE_FORMAT_Y16_U16_V16_444_UNORM",
   "y16_u16_v16_444_unorm",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR3,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_p010_description = {
   PIPE_FORMAT_P010,
   "PIPE_FORMAT_P010",
   "p010",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_p012_description = {
   PIPE_FORMAT_P012,
   "PIPE_FORMAT_P012",
   "p012",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_p016_description = {
   PIPE_FORMAT_P016,
   "PIPE_FORMAT_P016",
   "p016",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_p030_description = {
   PIPE_FORMAT_P030,
   "PIPE_FORMAT_P030",
   "p030",
   {1, 1, 1, 0},	/* block */
   UTIL_FORMAT_LAYOUT_PLANAR2,
   0,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y210_description = {
   PIPE_FORMAT_Y210,
   "PIPE_FORMAT_Y210",
   "y210",
   {2, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y212_description = {
   PIPE_FORMAT_Y212,
   "PIPE_FORMAT_Y212",
   "y212",
   {2, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y216_description = {
   PIPE_FORMAT_Y216,
   "PIPE_FORMAT_Y216",
   "y216",
   {2, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_SUBSAMPLED,
   1,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 64, 0},	/* x = x */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* y */
      PIPE_SWIZZLE_Y,	/* u */
      PIPE_SWIZZLE_Z,	/* v */
      PIPE_SWIZZLE_1	/* ignored */
   },
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y410_description = {
   PIPE_FORMAT_Y410,
   "PIPE_FORMAT_Y410",
   "y410",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 2, 30}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* y */
      PIPE_SWIZZLE_Z,	/* u */
      PIPE_SWIZZLE_X,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* y */
      PIPE_SWIZZLE_Z,	/* u */
      PIPE_SWIZZLE_X,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y412_description = {
   PIPE_FORMAT_Y412,
   "PIPE_FORMAT_Y412",
   "y412",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* y */
      PIPE_SWIZZLE_Z,	/* u */
      PIPE_SWIZZLE_X,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* y */
      PIPE_SWIZZLE_Z,	/* u */
      PIPE_SWIZZLE_X,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_y416_description = {
   PIPE_FORMAT_Y416,
   "PIPE_FORMAT_Y416",
   "y416",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_OTHER,
   4,	/* nr_channels */
   false,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0}	/* w = w */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = y */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* z = z */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48}	/* w = w */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* y */
      PIPE_SWIZZLE_Z,	/* u */
      PIPE_SWIZZLE_X,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* y */
      PIPE_SWIZZLE_Z,	/* u */
      PIPE_SWIZZLE_X,	/* v */
      PIPE_SWIZZLE_W	/* ignored */
   },
#endif
   UTIL_FORMAT_COLORSPACE_YUV,
};

const struct util_format_description
util_format_a4r4_unorm_description = {
   PIPE_FORMAT_A4R4_UNORM,
   "PIPE_FORMAT_A4R4_UNORM",
   "a4r4_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r4a4_unorm_description = {
   PIPE_FORMAT_R4A4_UNORM,
   "PIPE_FORMAT_R4A4_UNORM",
   "r4a4_unorm",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 4, 4},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8a8_unorm_description = {
   PIPE_FORMAT_R8A8_UNORM,
   "PIPE_FORMAT_R8A8_UNORM",
   "r8a8_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8r8_unorm_description = {
   PIPE_FORMAT_A8R8_UNORM,
   "PIPE_FORMAT_A8R8_UNORM",
   "a8r8_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10a2_uscaled_description = {
   PIPE_FORMAT_R10G10B10A2_USCALED,
   "PIPE_FORMAT_R10G10B10A2_USCALED",
   "r10g10b10a2_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10a2_sscaled_description = {
   PIPE_FORMAT_R10G10B10A2_SSCALED,
   "PIPE_FORMAT_R10G10B10A2_SSCALED",
   "r10g10b10a2_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10a2_snorm_description = {
   PIPE_FORMAT_R10G10B10A2_SNORM,
   "PIPE_FORMAT_R10G10B10A2_SNORM",
   "r10g10b10a2_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10a2_uscaled_description = {
   PIPE_FORMAT_B10G10R10A2_USCALED,
   "PIPE_FORMAT_B10G10R10A2_USCALED",
   "b10g10r10a2_uscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10a2_sscaled_description = {
   PIPE_FORMAT_B10G10R10A2_SSCALED,
   "PIPE_FORMAT_B10G10R10A2_SSCALED",
   "b10g10r10a2_sscaled",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10a2_snorm_description = {
   PIPE_FORMAT_B10G10R10A2_SNORM,
   "PIPE_FORMAT_B10G10R10A2_SNORM",
   "b10g10r10a2_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_uint_description = {
   PIPE_FORMAT_R8_UINT,
   "PIPE_FORMAT_R8_UINT",
   "r8_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_uint_description = {
   PIPE_FORMAT_R8G8_UINT,
   "PIPE_FORMAT_R8G8_UINT",
   "r8g8_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8_uint_description = {
   PIPE_FORMAT_R8G8B8_UINT,
   "PIPE_FORMAT_R8G8B8_UINT",
   "r8g8b8_uint",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8a8_uint_description = {
   PIPE_FORMAT_R8G8B8A8_UINT,
   "PIPE_FORMAT_R8G8B8A8_UINT",
   "r8g8b8a8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8_sint_description = {
   PIPE_FORMAT_R8_SINT,
   "PIPE_FORMAT_R8_SINT",
   "r8_sint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8_sint_description = {
   PIPE_FORMAT_R8G8_SINT,
   "PIPE_FORMAT_R8G8_SINT",
   "r8g8_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8_sint_description = {
   PIPE_FORMAT_R8G8B8_SINT,
   "PIPE_FORMAT_R8G8B8_SINT",
   "r8g8b8_sint",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8a8_sint_description = {
   PIPE_FORMAT_R8G8B8A8_SINT,
   "PIPE_FORMAT_R8G8B8A8_SINT",
   "r8g8b8a8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_uint_description = {
   PIPE_FORMAT_R16_UINT,
   "PIPE_FORMAT_R16_UINT",
   "r16_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_uint_description = {
   PIPE_FORMAT_R16G16_UINT,
   "PIPE_FORMAT_R16G16_UINT",
   "r16g16_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_uint_description = {
   PIPE_FORMAT_R16G16B16_UINT,
   "PIPE_FORMAT_R16G16B16_UINT",
   "r16g16b16_uint",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_uint_description = {
   PIPE_FORMAT_R16G16B16A16_UINT,
   "PIPE_FORMAT_R16G16B16A16_UINT",
   "r16g16b16a16_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16_sint_description = {
   PIPE_FORMAT_R16_SINT,
   "PIPE_FORMAT_R16_SINT",
   "r16_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16_sint_description = {
   PIPE_FORMAT_R16G16_SINT,
   "PIPE_FORMAT_R16G16_SINT",
   "r16g16_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16_sint_description = {
   PIPE_FORMAT_R16G16B16_SINT,
   "PIPE_FORMAT_R16G16B16_SINT",
   "r16g16b16_sint",
   {1, 1, 1, 48},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 32},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16a16_sint_description = {
   PIPE_FORMAT_R16G16B16A16_SINT,
   "PIPE_FORMAT_R16G16B16A16_SINT",
   "r16g16b16a16_sint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 48}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_uint_description = {
   PIPE_FORMAT_R32_UINT,
   "PIPE_FORMAT_R32_UINT",
   "r32_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_uint_description = {
   PIPE_FORMAT_R32G32_UINT,
   "PIPE_FORMAT_R32G32_UINT",
   "r32g32_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_uint_description = {
   PIPE_FORMAT_R32G32B32_UINT,
   "PIPE_FORMAT_R32G32B32_UINT",
   "r32g32b32_uint",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_uint_description = {
   PIPE_FORMAT_R32G32B32A32_UINT,
   "PIPE_FORMAT_R32G32B32A32_UINT",
   "r32g32b32a32_uint",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32_sint_description = {
   PIPE_FORMAT_R32_SINT,
   "PIPE_FORMAT_R32_SINT",
   "r32_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32_sint_description = {
   PIPE_FORMAT_R32G32_SINT,
   "PIPE_FORMAT_R32G32_SINT",
   "r32g32_sint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32_sint_description = {
   PIPE_FORMAT_R32G32B32_SINT,
   "PIPE_FORMAT_R32G32B32_SINT",
   "r32g32b32_sint",
   {1, 1, 1, 96},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 64},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32a32_sint_description = {
   PIPE_FORMAT_R32G32B32A32_SINT,
   "PIPE_FORMAT_R32G32B32A32_SINT",
   "r32g32b32a32_sint",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 96}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64_uint_description = {
   PIPE_FORMAT_R64_UINT,
   "PIPE_FORMAT_R64_UINT",
   "r64_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64_uint_description = {
   PIPE_FORMAT_R64G64_UINT,
   "PIPE_FORMAT_R64G64_UINT",
   "r64g64_uint",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 64},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64b64_uint_description = {
   PIPE_FORMAT_R64G64B64_UINT,
   "PIPE_FORMAT_R64G64B64_UINT",
   "r64g64b64_uint",
   {1, 1, 1, 192},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 128},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 128},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64b64a64_uint_description = {
   PIPE_FORMAT_R64G64B64A64_UINT,
   "PIPE_FORMAT_R64G64B64A64_UINT",
   "r64g64b64a64_uint",
   {1, 1, 1, 256},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 192},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 128},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 128},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 64, 192}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64_sint_description = {
   PIPE_FORMAT_R64_SINT,
   "PIPE_FORMAT_R64_SINT",
   "r64_sint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0},	/* x = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64_sint_description = {
   PIPE_FORMAT_R64G64_SINT,
   "PIPE_FORMAT_R64G64_SINT",
   "r64g64_sint",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 64},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 64},	/* y = g */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64b64_sint_description = {
   PIPE_FORMAT_R64G64B64_SINT,
   "PIPE_FORMAT_R64G64B64_SINT",
   "r64g64b64_sint",
   {1, 1, 1, 192},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 128},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 128},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r64g64b64a64_sint_description = {
   PIPE_FORMAT_R64G64B64A64_SINT,
   "PIPE_FORMAT_R64G64B64A64_SINT",
   "r64g64b64a64_sint",
   {1, 1, 1, 256},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 192},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 128},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 128},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 64, 192}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8_uint_description = {
   PIPE_FORMAT_A8_UINT,
   "PIPE_FORMAT_A8_UINT",
   "a8_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i8_uint_description = {
   PIPE_FORMAT_I8_UINT,
   "PIPE_FORMAT_I8_UINT",
   "i8_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8_uint_description = {
   PIPE_FORMAT_L8_UINT,
   "PIPE_FORMAT_L8_UINT",
   "l8_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8a8_uint_description = {
   PIPE_FORMAT_L8A8_UINT,
   "PIPE_FORMAT_L8A8_UINT",
   "l8a8_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8_sint_description = {
   PIPE_FORMAT_A8_SINT,
   "PIPE_FORMAT_A8_SINT",
   "a8_sint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i8_sint_description = {
   PIPE_FORMAT_I8_SINT,
   "PIPE_FORMAT_I8_SINT",
   "i8_sint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8_sint_description = {
   PIPE_FORMAT_L8_SINT,
   "PIPE_FORMAT_L8_SINT",
   "l8_sint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l8a8_sint_description = {
   PIPE_FORMAT_L8A8_SINT,
   "PIPE_FORMAT_L8A8_SINT",
   "l8a8_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a16_uint_description = {
   PIPE_FORMAT_A16_UINT,
   "PIPE_FORMAT_A16_UINT",
   "a16_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i16_uint_description = {
   PIPE_FORMAT_I16_UINT,
   "PIPE_FORMAT_I16_UINT",
   "i16_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16_uint_description = {
   PIPE_FORMAT_L16_UINT,
   "PIPE_FORMAT_L16_UINT",
   "l16_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16a16_uint_description = {
   PIPE_FORMAT_L16A16_UINT,
   "PIPE_FORMAT_L16A16_UINT",
   "l16a16_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a16_sint_description = {
   PIPE_FORMAT_A16_SINT,
   "PIPE_FORMAT_A16_SINT",
   "a16_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i16_sint_description = {
   PIPE_FORMAT_I16_SINT,
   "PIPE_FORMAT_I16_SINT",
   "i16_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16_sint_description = {
   PIPE_FORMAT_L16_SINT,
   "PIPE_FORMAT_L16_SINT",
   "l16_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l16a16_sint_description = {
   PIPE_FORMAT_L16A16_SINT,
   "PIPE_FORMAT_L16A16_SINT",
   "l16a16_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a32_uint_description = {
   PIPE_FORMAT_A32_UINT,
   "PIPE_FORMAT_A32_UINT",
   "a32_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i32_uint_description = {
   PIPE_FORMAT_I32_UINT,
   "PIPE_FORMAT_I32_UINT",
   "i32_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l32_uint_description = {
   PIPE_FORMAT_L32_UINT,
   "PIPE_FORMAT_L32_UINT",
   "l32_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l32a32_uint_description = {
   PIPE_FORMAT_L32A32_UINT,
   "PIPE_FORMAT_L32A32_UINT",
   "l32a32_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a32_sint_description = {
   PIPE_FORMAT_A32_SINT,
   "PIPE_FORMAT_A32_SINT",
   "a32_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_0,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_i32_sint_description = {
   PIPE_FORMAT_I32_SINT,
   "PIPE_FORMAT_I32_SINT",
   "i32_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = rgba */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l32_sint_description = {
   PIPE_FORMAT_L32_SINT,
   "PIPE_FORMAT_L32_SINT",
   "l32_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   1,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = rgb */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_l32a32_sint_description = {
   PIPE_FORMAT_L32A32_SINT,
   "PIPE_FORMAT_L32A32_SINT",
   "l32a32_sint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = rgb */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8_uint_description = {
   PIPE_FORMAT_B8G8R8_UINT,
   "PIPE_FORMAT_B8G8R8_UINT",
   "b8g8r8_uint",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8a8_uint_description = {
   PIPE_FORMAT_B8G8R8A8_UINT,
   "PIPE_FORMAT_B8G8R8A8_UINT",
   "b8g8r8a8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8_sint_description = {
   PIPE_FORMAT_B8G8R8_SINT,
   "PIPE_FORMAT_B8G8R8_SINT",
   "b8g8r8_sint",
   {1, 1, 1, 24},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b8g8r8a8_sint_description = {
   PIPE_FORMAT_B8G8R8A8_SINT,
   "PIPE_FORMAT_B8G8R8A8_SINT",
   "b8g8r8a8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8r8g8b8_uint_description = {
   PIPE_FORMAT_A8R8G8B8_UINT,
   "PIPE_FORMAT_A8R8G8B8_UINT",
   "a8r8g8b8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8b8g8r8_uint_description = {
   PIPE_FORMAT_A8B8G8R8_UINT,
   "PIPE_FORMAT_A8B8G8R8_UINT",
   "a8b8g8r8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a2r10g10b10_uint_description = {
   PIPE_FORMAT_A2R10G10B10_UINT,
   "PIPE_FORMAT_A2R10G10B10_UINT",
   "a2r10g10b10_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 30},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 20},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 10},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 2},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 12},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 22}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a2b10g10r10_uint_description = {
   PIPE_FORMAT_A2B10G10R10_UINT,
   "PIPE_FORMAT_A2B10G10R10_UINT",
   "a2b10g10r10_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 30},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 20},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 10},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 2},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 12},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 22}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10a2_uint_description = {
   PIPE_FORMAT_B10G10R10A2_UINT,
   "PIPE_FORMAT_B10G10R10A2_UINT",
   "b10g10r10a2_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10a2_sint_description = {
   PIPE_FORMAT_B10G10R10A2_SINT,
   "PIPE_FORMAT_B10G10R10A2_SINT",
   "b10g10r10a2_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r5g6b5_uint_description = {
   PIPE_FORMAT_R5G6B5_UINT,
   "PIPE_FORMAT_R5G6B5_UINT",
   "r5g6b5_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b5g6r5_uint_description = {
   PIPE_FORMAT_B5G6R5_UINT,
   "PIPE_FORMAT_B5G6R5_UINT",
   "b5g6r5_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r3g3b2_uint_description = {
   PIPE_FORMAT_R3G3B2_UINT,
   "PIPE_FORMAT_R3G3B2_UINT",
   "r3g3b2_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 5},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 2},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 3},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 6},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b2g3r3_uint_description = {
   PIPE_FORMAT_B2G3R3_UINT,
   "PIPE_FORMAT_B2G3R3_UINT",
   "b2g3r3_uint",
   {1, 1, 1, 8},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 6},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 3},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 2},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 3, 5},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r4g4b4a4_uint_description = {
   PIPE_FORMAT_R4G4B4A4_UINT,
   "PIPE_FORMAT_R4G4B4A4_UINT",
   "r4g4b4a4_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b4g4r4a4_uint_description = {
   PIPE_FORMAT_B4G4R4A4_UINT,
   "PIPE_FORMAT_B4G4R4A4_UINT",
   "b4g4r4a4_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a4r4g4b4_uint_description = {
   PIPE_FORMAT_A4R4G4B4_UINT,
   "PIPE_FORMAT_A4R4G4B4_UINT",
   "a4r4g4b4_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a4b4g4r4_uint_description = {
   PIPE_FORMAT_A4B4G4R4_UINT,
   "PIPE_FORMAT_A4B4G4R4_UINT",
   "a4b4g4r4_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 4},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 4, 12}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a1r5g5b5_uint_description = {
   PIPE_FORMAT_A1R5G5B5_UINT,
   "PIPE_FORMAT_A1R5G5B5_UINT",
   "a1r5g5b5_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 15},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 10},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 5},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0}	/* w = b */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 1},	/* y = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 6},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11}	/* w = b */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_W,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a1b5g5r5_uint_description = {
   PIPE_FORMAT_A1B5G5R5_UINT,
   "PIPE_FORMAT_A1B5G5R5_UINT",
   "a1b5g5r5_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 15},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 10},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 5},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 1},	/* y = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 6},	/* z = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r5g5b5a1_uint_description = {
   PIPE_FORMAT_R5G5B5A1_UINT,
   "PIPE_FORMAT_R5G5B5A1_UINT",
   "r5g5b5a1_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 1},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 10},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 15}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b5g5r5a1_uint_description = {
   PIPE_FORMAT_B5G5R5A1_UINT,
   "PIPE_FORMAT_B5G5R5A1_UINT",
   "b5g5r5a1_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 11},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 6},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 1},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 5, 10},	/* z = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 1, 15}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8x8_snorm_description = {
   PIPE_FORMAT_R8G8B8X8_SNORM,
   "PIPE_FORMAT_R8G8B8X8_SNORM",
   "r8g8b8x8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8x8_srgb_description = {
   PIPE_FORMAT_R8G8B8X8_SRGB,
   "PIPE_FORMAT_R8G8B8X8_SRGB",
   "r8g8b8x8_srgb",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r8g8b8x8_uint_description = {
   PIPE_FORMAT_R8G8B8X8_UINT,
   "PIPE_FORMAT_R8G8B8X8_UINT",
   "r8g8b8x8_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8g8b8x8_sint_description = {
   PIPE_FORMAT_R8G8B8X8_SINT,
   "PIPE_FORMAT_R8G8B8X8_SINT",
   "r8g8b8x8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10x2_unorm_description = {
   PIPE_FORMAT_B10G10R10X2_UNORM,
   "PIPE_FORMAT_B10G10R10X2_UNORM",
   "b10g10r10x2_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10x2_snorm_description = {
   PIPE_FORMAT_B10G10R10X2_SNORM,
   "PIPE_FORMAT_B10G10R10X2_SNORM",
   "b10g10r10x2_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b10g10r10x2_sint_description = {
   PIPE_FORMAT_B10G10R10X2_SINT,
   "PIPE_FORMAT_B10G10R10X2_SINT",
   "b10g10r10x2_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 22},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 2},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 20},	/* z = r */
      {UTIL_FORMAT_TYPE_VOID, false, false, 2, 30}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_X,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16x16_unorm_description = {
   PIPE_FORMAT_R16G16B16X16_UNORM,
   "PIPE_FORMAT_R16G16B16X16_UNORM",
   "r16g16b16x16_unorm",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 48}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16x16_snorm_description = {
   PIPE_FORMAT_R16G16B16X16_SNORM,
   "PIPE_FORMAT_R16G16B16X16_SNORM",
   "r16g16b16x16_snorm",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 48}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16x16_float_description = {
   PIPE_FORMAT_R16G16B16X16_FLOAT,
   "PIPE_FORMAT_R16G16B16X16_FLOAT",
   "r16g16b16x16_float",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 48}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16x16_uint_description = {
   PIPE_FORMAT_R16G16B16X16_UINT,
   "PIPE_FORMAT_R16G16B16X16_UINT",
   "r16g16b16x16_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 48}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16g16b16x16_sint_description = {
   PIPE_FORMAT_R16G16B16X16_SINT,
   "PIPE_FORMAT_R16G16B16X16_SINT",
   "r16g16b16x16_sint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 48},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 16, 48}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32x32_float_description = {
   PIPE_FORMAT_R32G32B32X32_FLOAT,
   "PIPE_FORMAT_R32G32B32X32_FLOAT",
   "r32g32b32x32_float",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 96}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32x32_uint_description = {
   PIPE_FORMAT_R32G32B32X32_UINT,
   "PIPE_FORMAT_R32G32B32X32_UINT",
   "r32g32b32x32_uint",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 96}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32g32b32x32_sint_description = {
   PIPE_FORMAT_R32G32B32X32_SINT,
   "PIPE_FORMAT_R32G32B32X32_SINT",
   "r32g32b32x32_sint",
   {1, 1, 1, 128},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 96},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 64},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 0}	/* w = x */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 64},	/* z = b */
      {UTIL_FORMAT_TYPE_VOID, false, false, 32, 96}	/* w = x */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8a8_snorm_description = {
   PIPE_FORMAT_R8A8_SNORM,
   "PIPE_FORMAT_R8A8_SNORM",
   "r8a8_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16a16_unorm_description = {
   PIPE_FORMAT_R16A16_UNORM,
   "PIPE_FORMAT_R16A16_UNORM",
   "r16a16_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16a16_snorm_description = {
   PIPE_FORMAT_R16A16_SNORM,
   "PIPE_FORMAT_R16A16_SNORM",
   "r16a16_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16a16_float_description = {
   PIPE_FORMAT_R16A16_FLOAT,
   "PIPE_FORMAT_R16A16_FLOAT",
   "r16a16_float",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32a32_float_description = {
   PIPE_FORMAT_R32A32_FLOAT,
   "PIPE_FORMAT_R32A32_FLOAT",
   "r32a32_float",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_FLOAT, false, false, 32, 32},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8a8_uint_description = {
   PIPE_FORMAT_R8A8_UINT,
   "PIPE_FORMAT_R8A8_UINT",
   "r8a8_uint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r8a8_sint_description = {
   PIPE_FORMAT_R8A8_SINT,
   "PIPE_FORMAT_R8A8_SINT",
   "r8a8_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16a16_uint_description = {
   PIPE_FORMAT_R16A16_UINT,
   "PIPE_FORMAT_R16A16_UINT",
   "r16a16_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r16a16_sint_description = {
   PIPE_FORMAT_R16A16_SINT,
   "PIPE_FORMAT_R16A16_SINT",
   "r16a16_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32a32_uint_description = {
   PIPE_FORMAT_R32A32_UINT,
   "PIPE_FORMAT_R32A32_UINT",
   "r32a32_uint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 32, 32},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r32a32_sint_description = {
   PIPE_FORMAT_R32A32_SINT,
   "PIPE_FORMAT_R32A32_SINT",
   "r32a32_sint",
   {1, 1, 1, 64},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   false,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 32, 32},	/* y = a */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_0,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_Y	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10a2_uint_description = {
   PIPE_FORMAT_R10G10B10A2_UINT,
   "PIPE_FORMAT_R10G10B10A2_UINT",
   "r10g10b10a2_uint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, false, true, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_r10g10b10a2_sint_description = {
   PIPE_FORMAT_R10G10B10A2_SINT,
   "PIPE_FORMAT_R10G10B10A2_SINT",
   "r10g10b10a2_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 22},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 12},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 2},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 2, 0}	/* w = a */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 10},	/* y = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 10, 20},	/* z = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 2, 30}	/* w = a */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* r */
      PIPE_SWIZZLE_Y,	/* g */
      PIPE_SWIZZLE_Z,	/* b */
      PIPE_SWIZZLE_W	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_b5g6r5_srgb_description = {
   PIPE_FORMAT_B5G6R5_SRGB,
   "PIPE_FORMAT_B5G6R5_SRGB",
   "b5g6r5_srgb",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = b */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* z = r */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Z,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_X,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_r5g6b5_srgb_description = {
   PIPE_FORMAT_R5G6B5_SRGB,
   "PIPE_FORMAT_R5G6B5_SRGB",
   "r5g6b5_srgb",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   3,	/* nr_channels */
   false,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 0},	/* x = r */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 6, 5},	/* y = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 5, 11},	/* z = b */
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_X,	/* sr */
      PIPE_SWIZZLE_Y,	/* sg */
      PIPE_SWIZZLE_Z,	/* sb */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_SRGB,
};

const struct util_format_description
util_format_g8r8_unorm_description = {
   PIPE_FORMAT_G8R8_UNORM,
   "PIPE_FORMAT_G8R8_UNORM",
   "g8r8_unorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* x = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 0},	/* x = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 8, 8},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8r8_snorm_description = {
   PIPE_FORMAT_G8R8_SNORM,
   "PIPE_FORMAT_G8R8_SNORM",
   "g8r8_snorm",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g8r8_sint_description = {
   PIPE_FORMAT_G8R8_SINT,
   "PIPE_FORMAT_G8R8_SINT",
   "g8r8_sint",
   {1, 1, 1, 16},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g16r16_unorm_description = {
   PIPE_FORMAT_G16R16_UNORM,
   "PIPE_FORMAT_G16R16_UNORM",
   "g16r16_unorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* x = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 0},	/* x = g */
      {UTIL_FORMAT_TYPE_UNSIGNED, true, false, 16, 16},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g16r16_snorm_description = {
   PIPE_FORMAT_G16R16_SNORM,
   "PIPE_FORMAT_G16R16_SNORM",
   "g16r16_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 0},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 16, 16},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_g16r16_sint_description = {
   PIPE_FORMAT_G16R16_SINT,
   "PIPE_FORMAT_G16R16_SINT",
   "g16r16_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   2,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 0},	/* x = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 16, 16},	/* y = r */
      {0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0}
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_Y,	/* r */
      PIPE_SWIZZLE_X,	/* g */
      PIPE_SWIZZLE_0,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8b8g8r8_snorm_description = {
   PIPE_FORMAT_A8B8G8R8_SNORM,
   "PIPE_FORMAT_A8B8G8R8_SNORM",
   "a8b8g8r8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_a8b8g8r8_sint_description = {
   PIPE_FORMAT_A8B8G8R8_SINT,
   "PIPE_FORMAT_A8B8G8R8_SINT",
   "a8b8g8r8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0},	/* x = a */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_X	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x8b8g8r8_snorm_description = {
   PIPE_FORMAT_X8B8G8R8_SNORM,
   "PIPE_FORMAT_X8B8G8R8_SNORM",
   "x8b8g8r8_snorm",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, true, false, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description
util_format_x8b8g8r8_sint_description = {
   PIPE_FORMAT_X8B8G8R8_SINT,
   "PIPE_FORMAT_X8B8G8R8_SINT",
   "x8b8g8r8_sint",
   {1, 1, 1, 32},	/* block */
   UTIL_FORMAT_LAYOUT_PLAIN,
   4,	/* nr_channels */
   true,	/* is_array */
   true,	/* is_bitmask */
   false,	/* is_mixed */
#if UTIL_ARCH_BIG_ENDIAN
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 24},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 0}	/* w = r */
   },
#else
   {
      {UTIL_FORMAT_TYPE_VOID, false, false, 8, 0},	/* x = x */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 8},	/* y = b */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 16},	/* z = g */
      {UTIL_FORMAT_TYPE_SIGNED, false, true, 8, 24}	/* w = r */
   },
#endif
#if UTIL_ARCH_BIG_ENDIAN
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#else
   {
      PIPE_SWIZZLE_W,	/* r */
      PIPE_SWIZZLE_Z,	/* g */
      PIPE_SWIZZLE_Y,	/* b */
      PIPE_SWIZZLE_1	/* a */
   },
#endif
   UTIL_FORMAT_COLORSPACE_RGB,
};

const struct util_format_description *
util_format_description(enum pipe_format format)
{
   if (format >= PIPE_FORMAT_COUNT) {
      return NULL;
   }

   switch (format) {
   case PIPE_FORMAT_NONE:
      return &util_format_none_description;
   case PIPE_FORMAT_B8G8R8A8_UNORM:
      return &util_format_b8g8r8a8_unorm_description;
   case PIPE_FORMAT_B8G8R8X8_UNORM:
      return &util_format_b8g8r8x8_unorm_description;
   case PIPE_FORMAT_B8G8R8X8_SNORM:
      return &util_format_b8g8r8x8_snorm_description;
   case PIPE_FORMAT_B8G8R8X8_UINT:
      return &util_format_b8g8r8x8_uint_description;
   case PIPE_FORMAT_B8G8R8X8_SINT:
      return &util_format_b8g8r8x8_sint_description;
   case PIPE_FORMAT_A8R8G8B8_UNORM:
      return &util_format_a8r8g8b8_unorm_description;
   case PIPE_FORMAT_A8R8G8B8_SNORM:
      return &util_format_a8r8g8b8_snorm_description;
   case PIPE_FORMAT_A8R8G8B8_SINT:
      return &util_format_a8r8g8b8_sint_description;
   case PIPE_FORMAT_X8R8G8B8_UNORM:
      return &util_format_x8r8g8b8_unorm_description;
   case PIPE_FORMAT_X8R8G8B8_SNORM:
      return &util_format_x8r8g8b8_snorm_description;
   case PIPE_FORMAT_X8R8G8B8_SINT:
      return &util_format_x8r8g8b8_sint_description;
   case PIPE_FORMAT_A8B8G8R8_UNORM:
      return &util_format_a8b8g8r8_unorm_description;
   case PIPE_FORMAT_X8B8G8R8_UNORM:
      return &util_format_x8b8g8r8_unorm_description;
   case PIPE_FORMAT_R8G8B8X8_UNORM:
      return &util_format_r8g8b8x8_unorm_description;
   case PIPE_FORMAT_R5G5B5A1_UNORM:
      return &util_format_r5g5b5a1_unorm_description;
   case PIPE_FORMAT_R5G5B5X1_UNORM:
      return &util_format_r5g5b5x1_unorm_description;
   case PIPE_FORMAT_B5G5R5X1_UNORM:
      return &util_format_b5g5r5x1_unorm_description;
   case PIPE_FORMAT_B5G5R5A1_UNORM:
      return &util_format_b5g5r5a1_unorm_description;
   case PIPE_FORMAT_X1B5G5R5_UNORM:
      return &util_format_x1b5g5r5_unorm_description;
   case PIPE_FORMAT_A1R5G5B5_UNORM:
      return &util_format_a1r5g5b5_unorm_description;
   case PIPE_FORMAT_X1R5G5B5_UNORM:
      return &util_format_x1r5g5b5_unorm_description;
   case PIPE_FORMAT_A1B5G5R5_UNORM:
      return &util_format_a1b5g5r5_unorm_description;
   case PIPE_FORMAT_R4G4B4A4_UNORM:
      return &util_format_r4g4b4a4_unorm_description;
   case PIPE_FORMAT_R4G4B4X4_UNORM:
      return &util_format_r4g4b4x4_unorm_description;
   case PIPE_FORMAT_B4G4R4A4_UNORM:
      return &util_format_b4g4r4a4_unorm_description;
   case PIPE_FORMAT_B4G4R4X4_UNORM:
      return &util_format_b4g4r4x4_unorm_description;
   case PIPE_FORMAT_A4R4G4B4_UNORM:
      return &util_format_a4r4g4b4_unorm_description;
   case PIPE_FORMAT_A4B4G4R4_UNORM:
      return &util_format_a4b4g4r4_unorm_description;
   case PIPE_FORMAT_R5G6B5_UNORM:
      return &util_format_r5g6b5_unorm_description;
   case PIPE_FORMAT_B5G6R5_UNORM:
      return &util_format_b5g6r5_unorm_description;
   case PIPE_FORMAT_R10G10B10A2_UNORM:
      return &util_format_r10g10b10a2_unorm_description;
   case PIPE_FORMAT_R10G10B10X2_UNORM:
      return &util_format_r10g10b10x2_unorm_description;
   case PIPE_FORMAT_B10G10R10A2_UNORM:
      return &util_format_b10g10r10a2_unorm_description;
   case PIPE_FORMAT_A2R10G10B10_UNORM:
      return &util_format_a2r10g10b10_unorm_description;
   case PIPE_FORMAT_A2B10G10R10_UNORM:
      return &util_format_a2b10g10r10_unorm_description;
   case PIPE_FORMAT_R3G3B2_UNORM:
      return &util_format_r3g3b2_unorm_description;
   case PIPE_FORMAT_B2G3R3_UNORM:
      return &util_format_b2g3r3_unorm_description;
   case PIPE_FORMAT_L8_UNORM:
      return &util_format_l8_unorm_description;
   case PIPE_FORMAT_A8_UNORM:
      return &util_format_a8_unorm_description;
   case PIPE_FORMAT_I8_UNORM:
      return &util_format_i8_unorm_description;
   case PIPE_FORMAT_L4A4_UNORM:
      return &util_format_l4a4_unorm_description;
   case PIPE_FORMAT_L8A8_UNORM:
      return &util_format_l8a8_unorm_description;
   case PIPE_FORMAT_L16_UNORM:
      return &util_format_l16_unorm_description;
   case PIPE_FORMAT_A16_UNORM:
      return &util_format_a16_unorm_description;
   case PIPE_FORMAT_I16_UNORM:
      return &util_format_i16_unorm_description;
   case PIPE_FORMAT_L16A16_UNORM:
      return &util_format_l16a16_unorm_description;
   case PIPE_FORMAT_A8_SNORM:
      return &util_format_a8_snorm_description;
   case PIPE_FORMAT_L8_SNORM:
      return &util_format_l8_snorm_description;
   case PIPE_FORMAT_L8A8_SNORM:
      return &util_format_l8a8_snorm_description;
   case PIPE_FORMAT_I8_SNORM:
      return &util_format_i8_snorm_description;
   case PIPE_FORMAT_A16_SNORM:
      return &util_format_a16_snorm_description;
   case PIPE_FORMAT_L16_SNORM:
      return &util_format_l16_snorm_description;
   case PIPE_FORMAT_L16A16_SNORM:
      return &util_format_l16a16_snorm_description;
   case PIPE_FORMAT_I16_SNORM:
      return &util_format_i16_snorm_description;
   case PIPE_FORMAT_A16_FLOAT:
      return &util_format_a16_float_description;
   case PIPE_FORMAT_L16_FLOAT:
      return &util_format_l16_float_description;
   case PIPE_FORMAT_L16A16_FLOAT:
      return &util_format_l16a16_float_description;
   case PIPE_FORMAT_I16_FLOAT:
      return &util_format_i16_float_description;
   case PIPE_FORMAT_A32_FLOAT:
      return &util_format_a32_float_description;
   case PIPE_FORMAT_L32_FLOAT:
      return &util_format_l32_float_description;
   case PIPE_FORMAT_L32A32_FLOAT:
      return &util_format_l32a32_float_description;
   case PIPE_FORMAT_I32_FLOAT:
      return &util_format_i32_float_description;
   case PIPE_FORMAT_L8_SRGB:
      return &util_format_l8_srgb_description;
   case PIPE_FORMAT_R8_SRGB:
      return &util_format_r8_srgb_description;
   case PIPE_FORMAT_L8A8_SRGB:
      return &util_format_l8a8_srgb_description;
   case PIPE_FORMAT_R8G8_SRGB:
      return &util_format_r8g8_srgb_description;
   case PIPE_FORMAT_R8G8B8_SRGB:
      return &util_format_r8g8b8_srgb_description;
   case PIPE_FORMAT_B8G8R8_SRGB:
      return &util_format_b8g8r8_srgb_description;
   case PIPE_FORMAT_R8G8B8A8_SRGB:
      return &util_format_r8g8b8a8_srgb_description;
   case PIPE_FORMAT_A8B8G8R8_SRGB:
      return &util_format_a8b8g8r8_srgb_description;
   case PIPE_FORMAT_X8B8G8R8_SRGB:
      return &util_format_x8b8g8r8_srgb_description;
   case PIPE_FORMAT_B8G8R8A8_SRGB:
      return &util_format_b8g8r8a8_srgb_description;
   case PIPE_FORMAT_B8G8R8X8_SRGB:
      return &util_format_b8g8r8x8_srgb_description;
   case PIPE_FORMAT_A8R8G8B8_SRGB:
      return &util_format_a8r8g8b8_srgb_description;
   case PIPE_FORMAT_X8R8G8B8_SRGB:
      return &util_format_x8r8g8b8_srgb_description;
   case PIPE_FORMAT_R8SG8SB8UX8U_NORM:
      return &util_format_r8sg8sb8ux8u_norm_description;
   case PIPE_FORMAT_R10SG10SB10SA2U_NORM:
      return &util_format_r10sg10sb10sa2u_norm_description;
   case PIPE_FORMAT_R5SG5SB6U_NORM:
      return &util_format_r5sg5sb6u_norm_description;
   case PIPE_FORMAT_S8_UINT:
      return &util_format_s8_uint_description;
   case PIPE_FORMAT_Z16_UNORM:
      return &util_format_z16_unorm_description;
   case PIPE_FORMAT_Z16_UNORM_S8_UINT:
      return &util_format_z16_unorm_s8_uint_description;
   case PIPE_FORMAT_Z32_UNORM:
      return &util_format_z32_unorm_description;
   case PIPE_FORMAT_Z32_FLOAT:
      return &util_format_z32_float_description;
   case PIPE_FORMAT_Z24_UNORM_S8_UINT:
      return &util_format_z24_unorm_s8_uint_description;
   case PIPE_FORMAT_S8_UINT_Z24_UNORM:
      return &util_format_s8_uint_z24_unorm_description;
   case PIPE_FORMAT_X24S8_UINT:
      return &util_format_x24s8_uint_description;
   case PIPE_FORMAT_S8X24_UINT:
      return &util_format_s8x24_uint_description;
   case PIPE_FORMAT_Z24X8_UNORM:
      return &util_format_z24x8_unorm_description;
   case PIPE_FORMAT_X8Z24_UNORM:
      return &util_format_x8z24_unorm_description;
   case PIPE_FORMAT_Z32_FLOAT_S8X24_UINT:
      return &util_format_z32_float_s8x24_uint_description;
   case PIPE_FORMAT_X32_S8X24_UINT:
      return &util_format_x32_s8x24_uint_description;
   case PIPE_FORMAT_Z24_UNORM_S8_UINT_AS_R8G8B8A8:
      return &util_format_z24_unorm_s8_uint_as_r8g8b8a8_description;
   case PIPE_FORMAT_UYVY:
      return &util_format_uyvy_description;
   case PIPE_FORMAT_VYUY:
      return &util_format_vyuy_description;
   case PIPE_FORMAT_YUYV:
      return &util_format_yuyv_description;
   case PIPE_FORMAT_YVYU:
      return &util_format_yvyu_description;
   case PIPE_FORMAT_AYUV:
      return &util_format_ayuv_description;
   case PIPE_FORMAT_XYUV:
      return &util_format_xyuv_description;
   case PIPE_FORMAT_R8G8_B8G8_UNORM:
      return &util_format_r8g8_b8g8_unorm_description;
   case PIPE_FORMAT_G8R8_G8B8_UNORM:
      return &util_format_g8r8_g8b8_unorm_description;
   case PIPE_FORMAT_G8R8_B8R8_UNORM:
      return &util_format_g8r8_b8r8_unorm_description;
   case PIPE_FORMAT_R8G8_R8B8_UNORM:
      return &util_format_r8g8_r8b8_unorm_description;
   case PIPE_FORMAT_B8R8_G8R8_UNORM:
      return &util_format_b8r8_g8r8_unorm_description;
   case PIPE_FORMAT_R8B8_R8G8_UNORM:
      return &util_format_r8b8_r8g8_unorm_description;
   case PIPE_FORMAT_G8B8_G8R8_UNORM:
      return &util_format_g8b8_g8r8_unorm_description;
   case PIPE_FORMAT_B8G8_R8G8_UNORM:
      return &util_format_b8g8_r8g8_unorm_description;
   case PIPE_FORMAT_R11G11B10_FLOAT:
      return &util_format_r11g11b10_float_description;
   case PIPE_FORMAT_R9G9B9E5_FLOAT:
      return &util_format_r9g9b9e5_float_description;
   case PIPE_FORMAT_R1_UNORM:
      return &util_format_r1_unorm_description;
   case PIPE_FORMAT_R8G8Bx_SNORM:
      return &util_format_r8g8bx_snorm_description;
   case PIPE_FORMAT_DXT1_RGB:
      return &util_format_dxt1_rgb_description;
   case PIPE_FORMAT_DXT1_RGBA:
      return &util_format_dxt1_rgba_description;
   case PIPE_FORMAT_DXT3_RGBA:
      return &util_format_dxt3_rgba_description;
   case PIPE_FORMAT_DXT5_RGBA:
      return &util_format_dxt5_rgba_description;
   case PIPE_FORMAT_DXT1_SRGB:
      return &util_format_dxt1_srgb_description;
   case PIPE_FORMAT_DXT1_SRGBA:
      return &util_format_dxt1_srgba_description;
   case PIPE_FORMAT_DXT3_SRGBA:
      return &util_format_dxt3_srgba_description;
   case PIPE_FORMAT_DXT5_SRGBA:
      return &util_format_dxt5_srgba_description;
   case PIPE_FORMAT_FXT1_RGB:
      return &util_format_fxt1_rgb_description;
   case PIPE_FORMAT_FXT1_RGBA:
      return &util_format_fxt1_rgba_description;
   case PIPE_FORMAT_RGTC1_UNORM:
      return &util_format_rgtc1_unorm_description;
   case PIPE_FORMAT_RGTC1_SNORM:
      return &util_format_rgtc1_snorm_description;
   case PIPE_FORMAT_RGTC2_UNORM:
      return &util_format_rgtc2_unorm_description;
   case PIPE_FORMAT_RGTC2_SNORM:
      return &util_format_rgtc2_snorm_description;
   case PIPE_FORMAT_LATC1_UNORM:
      return &util_format_latc1_unorm_description;
   case PIPE_FORMAT_LATC1_SNORM:
      return &util_format_latc1_snorm_description;
   case PIPE_FORMAT_LATC2_UNORM:
      return &util_format_latc2_unorm_description;
   case PIPE_FORMAT_LATC2_SNORM:
      return &util_format_latc2_snorm_description;
   case PIPE_FORMAT_ETC1_RGB8:
      return &util_format_etc1_rgb8_description;
   case PIPE_FORMAT_ETC2_RGB8:
      return &util_format_etc2_rgb8_description;
   case PIPE_FORMAT_ETC2_SRGB8:
      return &util_format_etc2_srgb8_description;
   case PIPE_FORMAT_ETC2_RGB8A1:
      return &util_format_etc2_rgb8a1_description;
   case PIPE_FORMAT_ETC2_SRGB8A1:
      return &util_format_etc2_srgb8a1_description;
   case PIPE_FORMAT_ETC2_RGBA8:
      return &util_format_etc2_rgba8_description;
   case PIPE_FORMAT_ETC2_SRGBA8:
      return &util_format_etc2_srgba8_description;
   case PIPE_FORMAT_ETC2_R11_UNORM:
      return &util_format_etc2_r11_unorm_description;
   case PIPE_FORMAT_ETC2_R11_SNORM:
      return &util_format_etc2_r11_snorm_description;
   case PIPE_FORMAT_ETC2_RG11_UNORM:
      return &util_format_etc2_rg11_unorm_description;
   case PIPE_FORMAT_ETC2_RG11_SNORM:
      return &util_format_etc2_rg11_snorm_description;
   case PIPE_FORMAT_BPTC_RGBA_UNORM:
      return &util_format_bptc_rgba_unorm_description;
   case PIPE_FORMAT_BPTC_SRGBA:
      return &util_format_bptc_srgba_description;
   case PIPE_FORMAT_BPTC_RGB_FLOAT:
      return &util_format_bptc_rgb_float_description;
   case PIPE_FORMAT_BPTC_RGB_UFLOAT:
      return &util_format_bptc_rgb_ufloat_description;
   case PIPE_FORMAT_ASTC_4x4:
      return &util_format_astc_4x4_description;
   case PIPE_FORMAT_ASTC_5x4:
      return &util_format_astc_5x4_description;
   case PIPE_FORMAT_ASTC_5x5:
      return &util_format_astc_5x5_description;
   case PIPE_FORMAT_ASTC_6x5:
      return &util_format_astc_6x5_description;
   case PIPE_FORMAT_ASTC_6x6:
      return &util_format_astc_6x6_description;
   case PIPE_FORMAT_ASTC_8x5:
      return &util_format_astc_8x5_description;
   case PIPE_FORMAT_ASTC_8x6:
      return &util_format_astc_8x6_description;
   case PIPE_FORMAT_ASTC_8x8:
      return &util_format_astc_8x8_description;
   case PIPE_FORMAT_ASTC_10x5:
      return &util_format_astc_10x5_description;
   case PIPE_FORMAT_ASTC_10x6:
      return &util_format_astc_10x6_description;
   case PIPE_FORMAT_ASTC_10x8:
      return &util_format_astc_10x8_description;
   case PIPE_FORMAT_ASTC_10x10:
      return &util_format_astc_10x10_description;
   case PIPE_FORMAT_ASTC_12x10:
      return &util_format_astc_12x10_description;
   case PIPE_FORMAT_ASTC_12x12:
      return &util_format_astc_12x12_description;
   case PIPE_FORMAT_ASTC_4x4_SRGB:
      return &util_format_astc_4x4_srgb_description;
   case PIPE_FORMAT_ASTC_5x4_SRGB:
      return &util_format_astc_5x4_srgb_description;
   case PIPE_FORMAT_ASTC_5x5_SRGB:
      return &util_format_astc_5x5_srgb_description;
   case PIPE_FORMAT_ASTC_6x5_SRGB:
      return &util_format_astc_6x5_srgb_description;
   case PIPE_FORMAT_ASTC_6x6_SRGB:
      return &util_format_astc_6x6_srgb_description;
   case PIPE_FORMAT_ASTC_8x5_SRGB:
      return &util_format_astc_8x5_srgb_description;
   case PIPE_FORMAT_ASTC_8x6_SRGB:
      return &util_format_astc_8x6_srgb_description;
   case PIPE_FORMAT_ASTC_8x8_SRGB:
      return &util_format_astc_8x8_srgb_description;
   case PIPE_FORMAT_ASTC_10x5_SRGB:
      return &util_format_astc_10x5_srgb_description;
   case PIPE_FORMAT_ASTC_10x6_SRGB:
      return &util_format_astc_10x6_srgb_description;
   case PIPE_FORMAT_ASTC_10x8_SRGB:
      return &util_format_astc_10x8_srgb_description;
   case PIPE_FORMAT_ASTC_10x10_SRGB:
      return &util_format_astc_10x10_srgb_description;
   case PIPE_FORMAT_ASTC_12x10_SRGB:
      return &util_format_astc_12x10_srgb_description;
   case PIPE_FORMAT_ASTC_12x12_SRGB:
      return &util_format_astc_12x12_srgb_description;
   case PIPE_FORMAT_ASTC_3x3x3:
      return &util_format_astc_3x3x3_description;
   case PIPE_FORMAT_ASTC_4x3x3:
      return &util_format_astc_4x3x3_description;
   case PIPE_FORMAT_ASTC_4x4x3:
      return &util_format_astc_4x4x3_description;
   case PIPE_FORMAT_ASTC_4x4x4:
      return &util_format_astc_4x4x4_description;
   case PIPE_FORMAT_ASTC_5x4x4:
      return &util_format_astc_5x4x4_description;
   case PIPE_FORMAT_ASTC_5x5x4:
      return &util_format_astc_5x5x4_description;
   case PIPE_FORMAT_ASTC_5x5x5:
      return &util_format_astc_5x5x5_description;
   case PIPE_FORMAT_ASTC_6x5x5:
      return &util_format_astc_6x5x5_description;
   case PIPE_FORMAT_ASTC_6x6x5:
      return &util_format_astc_6x6x5_description;
   case PIPE_FORMAT_ASTC_6x6x6:
      return &util_format_astc_6x6x6_description;
   case PIPE_FORMAT_ASTC_3x3x3_SRGB:
      return &util_format_astc_3x3x3_srgb_description;
   case PIPE_FORMAT_ASTC_4x3x3_SRGB:
      return &util_format_astc_4x3x3_srgb_description;
   case PIPE_FORMAT_ASTC_4x4x3_SRGB:
      return &util_format_astc_4x4x3_srgb_description;
   case PIPE_FORMAT_ASTC_4x4x4_SRGB:
      return &util_format_astc_4x4x4_srgb_description;
   case PIPE_FORMAT_ASTC_5x4x4_SRGB:
      return &util_format_astc_5x4x4_srgb_description;
   case PIPE_FORMAT_ASTC_5x5x4_SRGB:
      return &util_format_astc_5x5x4_srgb_description;
   case PIPE_FORMAT_ASTC_5x5x5_SRGB:
      return &util_format_astc_5x5x5_srgb_description;
   case PIPE_FORMAT_ASTC_6x5x5_SRGB:
      return &util_format_astc_6x5x5_srgb_description;
   case PIPE_FORMAT_ASTC_6x6x5_SRGB:
      return &util_format_astc_6x6x5_srgb_description;
   case PIPE_FORMAT_ASTC_6x6x6_SRGB:
      return &util_format_astc_6x6x6_srgb_description;
   case PIPE_FORMAT_ATC_RGB:
      return &util_format_atc_rgb_description;
   case PIPE_FORMAT_ATC_RGBA_EXPLICIT:
      return &util_format_atc_rgba_explicit_description;
   case PIPE_FORMAT_ATC_RGBA_INTERPOLATED:
      return &util_format_atc_rgba_interpolated_description;
   case PIPE_FORMAT_R64_FLOAT:
      return &util_format_r64_float_description;
   case PIPE_FORMAT_R64G64_FLOAT:
      return &util_format_r64g64_float_description;
   case PIPE_FORMAT_R64G64B64_FLOAT:
      return &util_format_r64g64b64_float_description;
   case PIPE_FORMAT_R64G64B64A64_FLOAT:
      return &util_format_r64g64b64a64_float_description;
   case PIPE_FORMAT_R32_FLOAT:
      return &util_format_r32_float_description;
   case PIPE_FORMAT_R32G32_FLOAT:
      return &util_format_r32g32_float_description;
   case PIPE_FORMAT_R32G32B32_FLOAT:
      return &util_format_r32g32b32_float_description;
   case PIPE_FORMAT_R32G32B32A32_FLOAT:
      return &util_format_r32g32b32a32_float_description;
   case PIPE_FORMAT_R32_UNORM:
      return &util_format_r32_unorm_description;
   case PIPE_FORMAT_R32G32_UNORM:
      return &util_format_r32g32_unorm_description;
   case PIPE_FORMAT_R32G32B32_UNORM:
      return &util_format_r32g32b32_unorm_description;
   case PIPE_FORMAT_R32G32B32A32_UNORM:
      return &util_format_r32g32b32a32_unorm_description;
   case PIPE_FORMAT_R32_USCALED:
      return &util_format_r32_uscaled_description;
   case PIPE_FORMAT_R32G32_USCALED:
      return &util_format_r32g32_uscaled_description;
   case PIPE_FORMAT_R32G32B32_USCALED:
      return &util_format_r32g32b32_uscaled_description;
   case PIPE_FORMAT_R32G32B32A32_USCALED:
      return &util_format_r32g32b32a32_uscaled_description;
   case PIPE_FORMAT_R32_SNORM:
      return &util_format_r32_snorm_description;
   case PIPE_FORMAT_R32G32_SNORM:
      return &util_format_r32g32_snorm_description;
   case PIPE_FORMAT_R32G32B32_SNORM:
      return &util_format_r32g32b32_snorm_description;
   case PIPE_FORMAT_R32G32B32A32_SNORM:
      return &util_format_r32g32b32a32_snorm_description;
   case PIPE_FORMAT_R32_SSCALED:
      return &util_format_r32_sscaled_description;
   case PIPE_FORMAT_R32G32_SSCALED:
      return &util_format_r32g32_sscaled_description;
   case PIPE_FORMAT_R32G32B32_SSCALED:
      return &util_format_r32g32b32_sscaled_description;
   case PIPE_FORMAT_R32G32B32A32_SSCALED:
      return &util_format_r32g32b32a32_sscaled_description;
   case PIPE_FORMAT_R16_FLOAT:
      return &util_format_r16_float_description;
   case PIPE_FORMAT_R16G16_FLOAT:
      return &util_format_r16g16_float_description;
   case PIPE_FORMAT_R16G16B16_FLOAT:
      return &util_format_r16g16b16_float_description;
   case PIPE_FORMAT_R16G16B16A16_FLOAT:
      return &util_format_r16g16b16a16_float_description;
   case PIPE_FORMAT_R16_UNORM:
      return &util_format_r16_unorm_description;
   case PIPE_FORMAT_R16G16_UNORM:
      return &util_format_r16g16_unorm_description;
   case PIPE_FORMAT_R16G16B16_UNORM:
      return &util_format_r16g16b16_unorm_description;
   case PIPE_FORMAT_R16G16B16A16_UNORM:
      return &util_format_r16g16b16a16_unorm_description;
   case PIPE_FORMAT_R16_USCALED:
      return &util_format_r16_uscaled_description;
   case PIPE_FORMAT_R16G16_USCALED:
      return &util_format_r16g16_uscaled_description;
   case PIPE_FORMAT_R16G16B16_USCALED:
      return &util_format_r16g16b16_uscaled_description;
   case PIPE_FORMAT_R16G16B16A16_USCALED:
      return &util_format_r16g16b16a16_uscaled_description;
   case PIPE_FORMAT_R16_SNORM:
      return &util_format_r16_snorm_description;
   case PIPE_FORMAT_R16G16_SNORM:
      return &util_format_r16g16_snorm_description;
   case PIPE_FORMAT_R16G16B16_SNORM:
      return &util_format_r16g16b16_snorm_description;
   case PIPE_FORMAT_R16G16B16A16_SNORM:
      return &util_format_r16g16b16a16_snorm_description;
   case PIPE_FORMAT_R16_SSCALED:
      return &util_format_r16_sscaled_description;
   case PIPE_FORMAT_R16G16_SSCALED:
      return &util_format_r16g16_sscaled_description;
   case PIPE_FORMAT_R16G16B16_SSCALED:
      return &util_format_r16g16b16_sscaled_description;
   case PIPE_FORMAT_R16G16B16A16_SSCALED:
      return &util_format_r16g16b16a16_sscaled_description;
   case PIPE_FORMAT_R8_UNORM:
      return &util_format_r8_unorm_description;
   case PIPE_FORMAT_R8G8_UNORM:
      return &util_format_r8g8_unorm_description;
   case PIPE_FORMAT_R8G8B8_UNORM:
      return &util_format_r8g8b8_unorm_description;
   case PIPE_FORMAT_B8G8R8_UNORM:
      return &util_format_b8g8r8_unorm_description;
   case PIPE_FORMAT_R8G8B8A8_UNORM:
      return &util_format_r8g8b8a8_unorm_description;
   case PIPE_FORMAT_R8_USCALED:
      return &util_format_r8_uscaled_description;
   case PIPE_FORMAT_R8G8_USCALED:
      return &util_format_r8g8_uscaled_description;
   case PIPE_FORMAT_R8G8B8_USCALED:
      return &util_format_r8g8b8_uscaled_description;
   case PIPE_FORMAT_B8G8R8_USCALED:
      return &util_format_b8g8r8_uscaled_description;
   case PIPE_FORMAT_R8G8B8A8_USCALED:
      return &util_format_r8g8b8a8_uscaled_description;
   case PIPE_FORMAT_B8G8R8A8_USCALED:
      return &util_format_b8g8r8a8_uscaled_description;
   case PIPE_FORMAT_A8B8G8R8_USCALED:
      return &util_format_a8b8g8r8_uscaled_description;
   case PIPE_FORMAT_R8_SNORM:
      return &util_format_r8_snorm_description;
   case PIPE_FORMAT_R8G8_SNORM:
      return &util_format_r8g8_snorm_description;
   case PIPE_FORMAT_R8G8B8_SNORM:
      return &util_format_r8g8b8_snorm_description;
   case PIPE_FORMAT_B8G8R8_SNORM:
      return &util_format_b8g8r8_snorm_description;
   case PIPE_FORMAT_R8G8B8A8_SNORM:
      return &util_format_r8g8b8a8_snorm_description;
   case PIPE_FORMAT_B8G8R8A8_SNORM:
      return &util_format_b8g8r8a8_snorm_description;
   case PIPE_FORMAT_R8_SSCALED:
      return &util_format_r8_sscaled_description;
   case PIPE_FORMAT_R8G8_SSCALED:
      return &util_format_r8g8_sscaled_description;
   case PIPE_FORMAT_R8G8B8_SSCALED:
      return &util_format_r8g8b8_sscaled_description;
   case PIPE_FORMAT_B8G8R8_SSCALED:
      return &util_format_b8g8r8_sscaled_description;
   case PIPE_FORMAT_R8G8B8A8_SSCALED:
      return &util_format_r8g8b8a8_sscaled_description;
   case PIPE_FORMAT_B8G8R8A8_SSCALED:
      return &util_format_b8g8r8a8_sscaled_description;
   case PIPE_FORMAT_A8B8G8R8_SSCALED:
      return &util_format_a8b8g8r8_sscaled_description;
   case PIPE_FORMAT_R32_FIXED:
      return &util_format_r32_fixed_description;
   case PIPE_FORMAT_R32G32_FIXED:
      return &util_format_r32g32_fixed_description;
   case PIPE_FORMAT_R32G32B32_FIXED:
      return &util_format_r32g32b32_fixed_description;
   case PIPE_FORMAT_R32G32B32A32_FIXED:
      return &util_format_r32g32b32a32_fixed_description;
   case PIPE_FORMAT_R10G10B10X2_USCALED:
      return &util_format_r10g10b10x2_uscaled_description;
   case PIPE_FORMAT_R10G10B10X2_SNORM:
      return &util_format_r10g10b10x2_snorm_description;
   case PIPE_FORMAT_R10G10B10X2_SINT:
      return &util_format_r10g10b10x2_sint_description;
   case PIPE_FORMAT_YV12:
      return &util_format_yv12_description;
   case PIPE_FORMAT_YV16:
      return &util_format_yv16_description;
   case PIPE_FORMAT_IYUV:
      return &util_format_iyuv_description;
   case PIPE_FORMAT_NV12:
      return &util_format_nv12_description;
   case PIPE_FORMAT_NV21:
      return &util_format_nv21_description;
   case PIPE_FORMAT_Y8_400_UNORM:
      return &util_format_y8_400_unorm_description;
   case PIPE_FORMAT_R8_G8B8_420_UNORM:
      return &util_format_r8_g8b8_420_unorm_description;
   case PIPE_FORMAT_R8_B8G8_420_UNORM:
      return &util_format_r8_b8g8_420_unorm_description;
   case PIPE_FORMAT_G8_B8R8_420_UNORM:
      return &util_format_g8_b8r8_420_unorm_description;
   case PIPE_FORMAT_R8_G8_B8_420_UNORM:
      return &util_format_r8_g8_b8_420_unorm_description;
   case PIPE_FORMAT_R8_B8_G8_420_UNORM:
      return &util_format_r8_b8_g8_420_unorm_description;
   case PIPE_FORMAT_G8_B8_R8_420_UNORM:
      return &util_format_g8_b8_r8_420_unorm_description;
   case PIPE_FORMAT_R8_G8_B8_UNORM:
      return &util_format_r8_g8_b8_unorm_description;
   case PIPE_FORMAT_Y8_UNORM:
      return &util_format_y8_unorm_description;
   case PIPE_FORMAT_Y8_U8_V8_422_UNORM:
      return &util_format_y8_u8_v8_422_unorm_description;
   case PIPE_FORMAT_Y8_U8V8_422_UNORM:
      return &util_format_y8_u8v8_422_unorm_description;
   case PIPE_FORMAT_Y8_U8_V8_444_UNORM:
      return &util_format_y8_u8_v8_444_unorm_description;
   case PIPE_FORMAT_Y16_U16_V16_420_UNORM:
      return &util_format_y16_u16_v16_420_unorm_description;
   case PIPE_FORMAT_Y16_U16_V16_422_UNORM:
      return &util_format_y16_u16_v16_422_unorm_description;
   case PIPE_FORMAT_Y16_U16V16_422_UNORM:
      return &util_format_y16_u16v16_422_unorm_description;
   case PIPE_FORMAT_Y16_U16_V16_444_UNORM:
      return &util_format_y16_u16_v16_444_unorm_description;
   case PIPE_FORMAT_P010:
      return &util_format_p010_description;
   case PIPE_FORMAT_P012:
      return &util_format_p012_description;
   case PIPE_FORMAT_P016:
      return &util_format_p016_description;
   case PIPE_FORMAT_P030:
      return &util_format_p030_description;
   case PIPE_FORMAT_Y210:
      return &util_format_y210_description;
   case PIPE_FORMAT_Y212:
      return &util_format_y212_description;
   case PIPE_FORMAT_Y216:
      return &util_format_y216_description;
   case PIPE_FORMAT_Y410:
      return &util_format_y410_description;
   case PIPE_FORMAT_Y412:
      return &util_format_y412_description;
   case PIPE_FORMAT_Y416:
      return &util_format_y416_description;
   case PIPE_FORMAT_A4R4_UNORM:
      return &util_format_a4r4_unorm_description;
   case PIPE_FORMAT_R4A4_UNORM:
      return &util_format_r4a4_unorm_description;
   case PIPE_FORMAT_R8A8_UNORM:
      return &util_format_r8a8_unorm_description;
   case PIPE_FORMAT_A8R8_UNORM:
      return &util_format_a8r8_unorm_description;
   case PIPE_FORMAT_R10G10B10A2_USCALED:
      return &util_format_r10g10b10a2_uscaled_description;
   case PIPE_FORMAT_R10G10B10A2_SSCALED:
      return &util_format_r10g10b10a2_sscaled_description;
   case PIPE_FORMAT_R10G10B10A2_SNORM:
      return &util_format_r10g10b10a2_snorm_description;
   case PIPE_FORMAT_B10G10R10A2_USCALED:
      return &util_format_b10g10r10a2_uscaled_description;
   case PIPE_FORMAT_B10G10R10A2_SSCALED:
      return &util_format_b10g10r10a2_sscaled_description;
   case PIPE_FORMAT_B10G10R10A2_SNORM:
      return &util_format_b10g10r10a2_snorm_description;
   case PIPE_FORMAT_R8_UINT:
      return &util_format_r8_uint_description;
   case PIPE_FORMAT_R8G8_UINT:
      return &util_format_r8g8_uint_description;
   case PIPE_FORMAT_R8G8B8_UINT:
      return &util_format_r8g8b8_uint_description;
   case PIPE_FORMAT_R8G8B8A8_UINT:
      return &util_format_r8g8b8a8_uint_description;
   case PIPE_FORMAT_R8_SINT:
      return &util_format_r8_sint_description;
   case PIPE_FORMAT_R8G8_SINT:
      return &util_format_r8g8_sint_description;
   case PIPE_FORMAT_R8G8B8_SINT:
      return &util_format_r8g8b8_sint_description;
   case PIPE_FORMAT_R8G8B8A8_SINT:
      return &util_format_r8g8b8a8_sint_description;
   case PIPE_FORMAT_R16_UINT:
      return &util_format_r16_uint_description;
   case PIPE_FORMAT_R16G16_UINT:
      return &util_format_r16g16_uint_description;
   case PIPE_FORMAT_R16G16B16_UINT:
      return &util_format_r16g16b16_uint_description;
   case PIPE_FORMAT_R16G16B16A16_UINT:
      return &util_format_r16g16b16a16_uint_description;
   case PIPE_FORMAT_R16_SINT:
      return &util_format_r16_sint_description;
   case PIPE_FORMAT_R16G16_SINT:
      return &util_format_r16g16_sint_description;
   case PIPE_FORMAT_R16G16B16_SINT:
      return &util_format_r16g16b16_sint_description;
   case PIPE_FORMAT_R16G16B16A16_SINT:
      return &util_format_r16g16b16a16_sint_description;
   case PIPE_FORMAT_R32_UINT:
      return &util_format_r32_uint_description;
   case PIPE_FORMAT_R32G32_UINT:
      return &util_format_r32g32_uint_description;
   case PIPE_FORMAT_R32G32B32_UINT:
      return &util_format_r32g32b32_uint_description;
   case PIPE_FORMAT_R32G32B32A32_UINT:
      return &util_format_r32g32b32a32_uint_description;
   case PIPE_FORMAT_R32_SINT:
      return &util_format_r32_sint_description;
   case PIPE_FORMAT_R32G32_SINT:
      return &util_format_r32g32_sint_description;
   case PIPE_FORMAT_R32G32B32_SINT:
      return &util_format_r32g32b32_sint_description;
   case PIPE_FORMAT_R32G32B32A32_SINT:
      return &util_format_r32g32b32a32_sint_description;
   case PIPE_FORMAT_R64_UINT:
      return &util_format_r64_uint_description;
   case PIPE_FORMAT_R64G64_UINT:
      return &util_format_r64g64_uint_description;
   case PIPE_FORMAT_R64G64B64_UINT:
      return &util_format_r64g64b64_uint_description;
   case PIPE_FORMAT_R64G64B64A64_UINT:
      return &util_format_r64g64b64a64_uint_description;
   case PIPE_FORMAT_R64_SINT:
      return &util_format_r64_sint_description;
   case PIPE_FORMAT_R64G64_SINT:
      return &util_format_r64g64_sint_description;
   case PIPE_FORMAT_R64G64B64_SINT:
      return &util_format_r64g64b64_sint_description;
   case PIPE_FORMAT_R64G64B64A64_SINT:
      return &util_format_r64g64b64a64_sint_description;
   case PIPE_FORMAT_A8_UINT:
      return &util_format_a8_uint_description;
   case PIPE_FORMAT_I8_UINT:
      return &util_format_i8_uint_description;
   case PIPE_FORMAT_L8_UINT:
      return &util_format_l8_uint_description;
   case PIPE_FORMAT_L8A8_UINT:
      return &util_format_l8a8_uint_description;
   case PIPE_FORMAT_A8_SINT:
      return &util_format_a8_sint_description;
   case PIPE_FORMAT_I8_SINT:
      return &util_format_i8_sint_description;
   case PIPE_FORMAT_L8_SINT:
      return &util_format_l8_sint_description;
   case PIPE_FORMAT_L8A8_SINT:
      return &util_format_l8a8_sint_description;
   case PIPE_FORMAT_A16_UINT:
      return &util_format_a16_uint_description;
   case PIPE_FORMAT_I16_UINT:
      return &util_format_i16_uint_description;
   case PIPE_FORMAT_L16_UINT:
      return &util_format_l16_uint_description;
   case PIPE_FORMAT_L16A16_UINT:
      return &util_format_l16a16_uint_description;
   case PIPE_FORMAT_A16_SINT:
      return &util_format_a16_sint_description;
   case PIPE_FORMAT_I16_SINT:
      return &util_format_i16_sint_description;
   case PIPE_FORMAT_L16_SINT:
      return &util_format_l16_sint_description;
   case PIPE_FORMAT_L16A16_SINT:
      return &util_format_l16a16_sint_description;
   case PIPE_FORMAT_A32_UINT:
      return &util_format_a32_uint_description;
   case PIPE_FORMAT_I32_UINT:
      return &util_format_i32_uint_description;
   case PIPE_FORMAT_L32_UINT:
      return &util_format_l32_uint_description;
   case PIPE_FORMAT_L32A32_UINT:
      return &util_format_l32a32_uint_description;
   case PIPE_FORMAT_A32_SINT:
      return &util_format_a32_sint_description;
   case PIPE_FORMAT_I32_SINT:
      return &util_format_i32_sint_description;
   case PIPE_FORMAT_L32_SINT:
      return &util_format_l32_sint_description;
   case PIPE_FORMAT_L32A32_SINT:
      return &util_format_l32a32_sint_description;
   case PIPE_FORMAT_B8G8R8_UINT:
      return &util_format_b8g8r8_uint_description;
   case PIPE_FORMAT_B8G8R8A8_UINT:
      return &util_format_b8g8r8a8_uint_description;
   case PIPE_FORMAT_B8G8R8_SINT:
      return &util_format_b8g8r8_sint_description;
   case PIPE_FORMAT_B8G8R8A8_SINT:
      return &util_format_b8g8r8a8_sint_description;
   case PIPE_FORMAT_A8R8G8B8_UINT:
      return &util_format_a8r8g8b8_uint_description;
   case PIPE_FORMAT_A8B8G8R8_UINT:
      return &util_format_a8b8g8r8_uint_description;
   case PIPE_FORMAT_A2R10G10B10_UINT:
      return &util_format_a2r10g10b10_uint_description;
   case PIPE_FORMAT_A2B10G10R10_UINT:
      return &util_format_a2b10g10r10_uint_description;
   case PIPE_FORMAT_B10G10R10A2_UINT:
      return &util_format_b10g10r10a2_uint_description;
   case PIPE_FORMAT_B10G10R10A2_SINT:
      return &util_format_b10g10r10a2_sint_description;
   case PIPE_FORMAT_R5G6B5_UINT:
      return &util_format_r5g6b5_uint_description;
   case PIPE_FORMAT_B5G6R5_UINT:
      return &util_format_b5g6r5_uint_description;
   case PIPE_FORMAT_R3G3B2_UINT:
      return &util_format_r3g3b2_uint_description;
   case PIPE_FORMAT_B2G3R3_UINT:
      return &util_format_b2g3r3_uint_description;
   case PIPE_FORMAT_R4G4B4A4_UINT:
      return &util_format_r4g4b4a4_uint_description;
   case PIPE_FORMAT_B4G4R4A4_UINT:
      return &util_format_b4g4r4a4_uint_description;
   case PIPE_FORMAT_A4R4G4B4_UINT:
      return &util_format_a4r4g4b4_uint_description;
   case PIPE_FORMAT_A4B4G4R4_UINT:
      return &util_format_a4b4g4r4_uint_description;
   case PIPE_FORMAT_A1R5G5B5_UINT:
      return &util_format_a1r5g5b5_uint_description;
   case PIPE_FORMAT_A1B5G5R5_UINT:
      return &util_format_a1b5g5r5_uint_description;
   case PIPE_FORMAT_R5G5B5A1_UINT:
      return &util_format_r5g5b5a1_uint_description;
   case PIPE_FORMAT_B5G5R5A1_UINT:
      return &util_format_b5g5r5a1_uint_description;
   case PIPE_FORMAT_R8G8B8X8_SNORM:
      return &util_format_r8g8b8x8_snorm_description;
   case PIPE_FORMAT_R8G8B8X8_SRGB:
      return &util_format_r8g8b8x8_srgb_description;
   case PIPE_FORMAT_R8G8B8X8_UINT:
      return &util_format_r8g8b8x8_uint_description;
   case PIPE_FORMAT_R8G8B8X8_SINT:
      return &util_format_r8g8b8x8_sint_description;
   case PIPE_FORMAT_B10G10R10X2_UNORM:
      return &util_format_b10g10r10x2_unorm_description;
   case PIPE_FORMAT_B10G10R10X2_SNORM:
      return &util_format_b10g10r10x2_snorm_description;
   case PIPE_FORMAT_B10G10R10X2_SINT:
      return &util_format_b10g10r10x2_sint_description;
   case PIPE_FORMAT_R16G16B16X16_UNORM:
      return &util_format_r16g16b16x16_unorm_description;
   case PIPE_FORMAT_R16G16B16X16_SNORM:
      return &util_format_r16g16b16x16_snorm_description;
   case PIPE_FORMAT_R16G16B16X16_FLOAT:
      return &util_format_r16g16b16x16_float_description;
   case PIPE_FORMAT_R16G16B16X16_UINT:
      return &util_format_r16g16b16x16_uint_description;
   case PIPE_FORMAT_R16G16B16X16_SINT:
      return &util_format_r16g16b16x16_sint_description;
   case PIPE_FORMAT_R32G32B32X32_FLOAT:
      return &util_format_r32g32b32x32_float_description;
   case PIPE_FORMAT_R32G32B32X32_UINT:
      return &util_format_r32g32b32x32_uint_description;
   case PIPE_FORMAT_R32G32B32X32_SINT:
      return &util_format_r32g32b32x32_sint_description;
   case PIPE_FORMAT_R8A8_SNORM:
      return &util_format_r8a8_snorm_description;
   case PIPE_FORMAT_R16A16_UNORM:
      return &util_format_r16a16_unorm_description;
   case PIPE_FORMAT_R16A16_SNORM:
      return &util_format_r16a16_snorm_description;
   case PIPE_FORMAT_R16A16_FLOAT:
      return &util_format_r16a16_float_description;
   case PIPE_FORMAT_R32A32_FLOAT:
      return &util_format_r32a32_float_description;
   case PIPE_FORMAT_R8A8_UINT:
      return &util_format_r8a8_uint_description;
   case PIPE_FORMAT_R8A8_SINT:
      return &util_format_r8a8_sint_description;
   case PIPE_FORMAT_R16A16_UINT:
      return &util_format_r16a16_uint_description;
   case PIPE_FORMAT_R16A16_SINT:
      return &util_format_r16a16_sint_description;
   case PIPE_FORMAT_R32A32_UINT:
      return &util_format_r32a32_uint_description;
   case PIPE_FORMAT_R32A32_SINT:
      return &util_format_r32a32_sint_description;
   case PIPE_FORMAT_R10G10B10A2_UINT:
      return &util_format_r10g10b10a2_uint_description;
   case PIPE_FORMAT_R10G10B10A2_SINT:
      return &util_format_r10g10b10a2_sint_description;
   case PIPE_FORMAT_B5G6R5_SRGB:
      return &util_format_b5g6r5_srgb_description;
   case PIPE_FORMAT_R5G6B5_SRGB:
      return &util_format_r5g6b5_srgb_description;
   case PIPE_FORMAT_G8R8_UNORM:
      return &util_format_g8r8_unorm_description;
   case PIPE_FORMAT_G8R8_SNORM:
      return &util_format_g8r8_snorm_description;
   case PIPE_FORMAT_G8R8_SINT:
      return &util_format_g8r8_sint_description;
   case PIPE_FORMAT_G16R16_UNORM:
      return &util_format_g16r16_unorm_description;
   case PIPE_FORMAT_G16R16_SNORM:
      return &util_format_g16r16_snorm_description;
   case PIPE_FORMAT_G16R16_SINT:
      return &util_format_g16r16_sint_description;
   case PIPE_FORMAT_A8B8G8R8_SNORM:
      return &util_format_a8b8g8r8_snorm_description;
   case PIPE_FORMAT_A8B8G8R8_SINT:
      return &util_format_a8b8g8r8_sint_description;
   case PIPE_FORMAT_X8B8G8R8_SNORM:
      return &util_format_x8b8g8r8_snorm_description;
   case PIPE_FORMAT_X8B8G8R8_SINT:
      return &util_format_x8b8g8r8_sint_description;
   default:
      return NULL;
   }
}

